//保存信息
function SetStationPumpInfo(StationID, PumpInfoList) {
	if(PumpInfoList == null || PumpInfoList == undefined) {
		return;
	}
	if(PumpInfoList.Status == "exception" || PumpInfoList.Status == "error") {
		return;
	}
	var SaveStationPumpInfoList = JSON.stringify(PumpInfoList);

	plus.storage.setItem("StationPumpInfoList_" + StationID, SaveStationPumpInfoList);
};
//提取緩存信息
function GetStationPumpInfo(StationID, callback) {

	var stationPumpInfoList = plus.storage.getItem("StationPumpInfoList_" + StationID);
	//alert(stationPumpInfoList); 如果是null，则从后台传，如果不是null，则需要转化为字符串形式，进行提取数据进行页面构建
	if(stationPumpInfoList != null) { //如果不为空就直接回调函数
		callback(jQuery.parseJSON(stationPumpInfoList));
		return;
	}
	//直接在js里获取后台信息
	$.ajax({
		type: "get",
		//async: false,
		crossDomain: true,
		cache: false,
		contentType: "application/json;utf-8",
		dataType: 'jsonp',
		jsonp: "callbackparam",
		url: GlobalParas.ServiceUrlMinitor + "MobileServer/ProductHandler.ashx",
		data: {
			cmd: "GetPumpListByStationID",
			SoftType: GlobalParas.SoftType,
			PortType:GlobalParas.PortType,
			StationID: StationID
		},
		success: function(result) {
			if(result == null)
				return;

			if(result.Status == "error" || result.Status == "exception") {
				alert(result.Info);
				return;
			}
			if(result.length == 0) {
				alert("还未添加设备");
				return;
			}

			//把后台传的数据保存到缓存
			var SaveStationPumpInfoList = JSON.stringify(result);
			plus.storage.setItem("StationPumpInfoList_" + StationID, SaveStationPumpInfoList);

			callback(result);
		},
		error: function() {
			mui.alert('错误代码 57');
		}
	});

};
//清理所有泵站的泵的信息
function RemoveAllStationPumpInfo() {
	//plus.storage.removeItem("StationPumpInfoList_'+StationID+'");

	var numKeys = plus.storage.getLength();

	for(var i = 0; i < numKeys; i++) {
		var keyName = plus.storage.key(i);

		if(keyName.indexOf("StationPumpInfoList_") == 0) { // indexOf返回值为0则包含

			plus.storage.removeItem(keyName);

		}
	};
}

function SetLoginTime() {

	//	setTimeout(function(){ //15天删除缓存内设置
	//					plus.storage.removeItem("StationPumpInfoList_" + StationID);
	//					
	//				},24*60*60*1000*15);

	var lastRemoveTime = plus.storage.getItem("lastRemoveTime"); //上次清理的时间
	var lastLoginTime = plus.storage.getItem("lastLoginTime"); //上次登录的时间
	if(lastRemoveTime == null) {
		var nowTime = new Date();
		plus.storage.setItem("lastRemoveTime", nowTime.Format("yyyy-MM-dd H:mm:ss"));
		return;
	}
	lastRemoveTime = getDateFromString(lastRemoveTime); //缓存中提取出来的
	var nowTime = new Date(); //当前时间
	var timespan = (nowTime - lastRemoveTime) / (3600 * 1000);

	if(timespan > 20) {
		RemoveAllStationPumpInfo();

		plus.storage.setItem("lastRemoveTime", nowTime.Format("yyyy-MM-dd H:mm:ss"));
		plus.storage.setItem("lastLoginTime", nowTime.Format("yyyy-MM-dd H:mm:ss"));
	}
	return;
}

//警报通知的设置// 请求后台获取设置
function GetAlarmNoticeSetInfo(UserID, callback) {
	RemoveAlarmNoticeSetEveryTimeSet();

	//先获取本地缓存中是否有设置
	var StorageAlarmInfoList = jQuery.parseJSON(plus.storage.getItem("AlarmNoticSet" + UserID));

	//如果没有设置 就请求后台的设置
	if(StorageAlarmInfoList != null) {
		callback(StorageAlarmInfoList);
		return;

	}
return;
	$.ajax({
		type: "get",
		//async: false,
		crossDomain: true,
		cache: true,
		contentType: "application/json;utf-8",
		dataType: 'jsonp',
		jsonp: "callbackparam",
		url: GlobalParas.ServiceUrlMinitor + "BaseInfo/S/UserHandler.ashx",
		data: {
			cmd: "GetAlarmNoticeSettingInApp",
			SoftType: "app",
			UserID: UserID
		},
		success: function(result) {
			if(result == null)
				return;

			if(result.Status == "error" || result.Status == "exception") {
				mui.alert(result.Info);
				return;
			}
			callback(result);

		},
		error: function() {
			mui.alert('错误代码 459');
		}

	});
}

//保存警报设置
function SetAlarmNoticeSetInfo(UserID, AlarmNoticSet, callback) {

	if(AlarmNoticSet == null || AlarmNoticSet == undefined) {
		callback("Error:157");
		return;
	}
	if(AlarmNoticSet.DispStatus == null) {
		callback("Error:160");
		return;
	}

	if(AlarmNoticSet.IsDispDescrip == null) {
		callback("Error:163");
		return;
	}
	if(AlarmNoticSet.VoiceType == null) {
		callback("Error:166");
		return;
	}
	if(AlarmNoticSet.VibratorType == null) {
		callback("Error:169");
		return;
	}

	//保存到本地
	var StorageAlarmNoticeList = JSON.stringify(AlarmNoticSet);

	plus.storage.setItem("AlarmNoticSet" + UserID, StorageAlarmNoticeList);
return;
	//设置放到后台
	$.ajax({
		type: "post",
		async: false,
		crossDomain: true,
		cache: true,
		contentType: "application/json;utf-8",
		dataType: 'jsonp',
		jsonp: "callbackparam",
		url: GlobalParas.ServiceUrlMinitor + "BaseInfo/S/UserHandler.ashx",
		data: {
			cmd: "SetAlarmNoticeSettingInApp",
			SoftType: "app",
			UserID: UserID,
			DispStatus: AlarmNoticSet.DispStatus,
			IsDispDescrip: AlarmNoticSet.IsDispDescrip,
			VoiceType: AlarmNoticSet.VoiceType,
			VibratorType: AlarmNoticSet.VibratorType
		},
		success: function(result) {
			if(result == null) {
				callback("Error:200");
				return;
			}

			if(result.Status == "error" || result.Status == "exception") {
				callback(result.Info);
				return;
			}

			callback(null);

		},
		error: function() {
			mui.alert('错误代码 459');
		}
	});
}

//清除警报设置缓存
function RemoveAllAlarmNoticeSet() {
	var numKeys = plus.storage.getLength();

	for(var i = 0; i < numKeys; i++) {
		var keyName = plus.storage.key(i);

		if(keyName.indexOf("AlarmNoticSet") == 0) { // indexOf返回值为0则包含

			plus.storage.removeItem(keyName);

		}
	};
}

function RemoveAlarmNoticeSetEveryTimeSet() {
	var lastRemoveAlarmTime = plus.storage.getItem("lastRemoveAlarmTime");

	if(lastRemoveAlarmTime == null) {
		var nowTime = new Date();
		var StrTime = nowTime.Format("yyyy-MM-dd H:mm:ss");
		plus.storage.setItem("lastRemoveAlarmTime", StrTime);
		return;
	}
	lastRemoveAlarmTime = getDateFromString(lastRemoveAlarmTime); //缓存中提取出来的
	var nowTime = new Date(); //当前时间
	var timespan = (nowTime - lastRemoveAlarmTime) / (3600 * 1000);

	if(timespan > 20) {
		RemoveAllAlarmNoticeSet();

		plus.storage.setItem("lastRemoveAlarmTime", nowTime.Format("yyyy-MM-dd H:mm:ss"));

	}
	return;
}