(function() {
	var indexImage = 1;
	var size = null;
	var imageIndexIdNum = 0;

	var repairRequest = {
		ContentTitle: document.getElementById('ContentTitle'),
		Description: document.getElementById('Description'),
		imageList: document.getElementById('image-list'),
		submitbtn: document.getElementById('submitbtn')
	};

	repairRequest.files = [];
	repairRequest.uploader = null;
	repairRequest.deviceInfo = null;
	mui.plusReady(function() {
		//设备信息，无需修改
		repairRequest.deviceInfo = {
			appid: plus.runtime.appid,
			imei: plus.device.imei, //设备标识
			images: repairRequest.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: plus.runtime.version,
			plus_version: plus.runtime.innerVersion, //基座版本号
			os: mui.os.version,
			net: '' + plus.networkinfo.getCurrentType()
		}
	});
	/**
	 *提交成功之后，恢复表单项 
	 */
	repairRequest.clearForm = function() {
		repairRequest.ContentTitle.value = '';
		repairRequest.imageList.innerHTML = '';
		indexImage = 0;
	};

	/**
	 *获取图片数量
	 */
	repairRequest.getFileInputArray = function() {
		return [].slice.call(repairRequest.imageList.querySelectorAll('.file'));
	};
	/**
	 *添加图片
	 */
	repairRequest.addFile = function(path) {
		repairRequest.files.push({
			name: "images" + indexImage,
			path: path
		});
		indexImage++;
	};
	/**
	 * 初始化图片域占位
	 */
	repairRequest.newPlaceholder = function() {
		var fileInputArray = repairRequest.getFileInputArray();
		if(fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var up = document.createElement("div");
		up.setAttribute('class', 'image-up')
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				repairRequest.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);

		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);
			repairRequest.sheet('选择照片', ['拍照', '相册'], function(ev) {
				var index = ev.index;
				var imagefile;
				if(index == 1) {
					var c = plus.camera.getCamera();
					c.captureImage(function(e) {
						//console.log("event:"+e);
						var name = e.substr(e.lastIndexOf('/') + 1);
						//console.log("name:" + name);
						plus.zip.compressImage({
							src: e,
							dst: '_doc/' + name,
							overwrite: true,
							quality: 50
						}, function(zip) {
							size += zip.size
							//console.log("filesize:" + zip.size + ",totalsize:" + size);
							if(size > (6 * 1024 * 1024)) {
								return mui.toast('文件超大,请重新选择~,最大图片尺寸是6M');
							}
							if(!self.parentNode.classList.contains('space')) { //已有图片
								repairRequest.files.splice(index - 1, 1, {
									name: "images" + index,
									path: e
								});
							} else { //加号
								placeholder.classList.remove('space');
								repairRequest.addFile(zip.target);
								repairRequest.newPlaceholder();
							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(' + zip.target + ')';
						}, function(zipe) {
							mui.toast('压缩失败！')
						});
					}, function(s) {
						console.log("error" + s);
					}, {
						filename: "_doc/head.png"
					})

				} else if(index == 2) {
					plus.gallery.pick(function(e) {
						//console.log("event:"+e);
						var name = e.substr(e.lastIndexOf('/') + 1);
						//console.log("name:" + name);
						plus.zip.compressImage({
							src: e,
							dst: '_doc/' + name,
							overwrite: true,
							quality: 50
						}, function(zip) {
							size += zip.size
							//console.log("filesize:" + zip.size + ",totalsize:" + size);
							if(size > (6 * 1024 * 1024)) {
								return mui.toast('文件超大,请重新选择~,最大图片尺寸是6M');
							}
							if(!self.parentNode.classList.contains('space')) { //已有图片
								repairRequest.files.splice(index - 1, 1, {
									name: "images" + index,
									path: e
								});
							} else { //加号
								placeholder.classList.remove('space');
								repairRequest.addFile(zip.target);
								repairRequest.newPlaceholder();
							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(' + zip.target + ')';
						}, function(zipe) {
							mui.toast('压缩失败！')
						});
					}, function(e) {
						//mui.toast(e.message);
					}, {});

				}

			});

		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		repairRequest.imageList.appendChild(placeholder);
	};
	repairRequest.newPlaceholder();

	repairRequest.sheet = function(title, btns, func) {
		if(title && btns && btns.length > 0) {
			var btnArray = [];
			for(var i = 0; i < btns.length; i++) {
				btnArray.push({
					title: btns[i]
				});
			}

			plus.nativeUI.actionSheet({
				title: title,
				cancel: '取消',
				buttons: btnArray
			}, function(e) {
				if(func) func(e);
			});
		}
	};

	/**
	 * 点击提交按钮
	 */
	repairRequest.submitbtn.addEventListener('tap', function(event) {
		setTimeout(function() {
			repairRequest.submitForm();
		}, 200); //过一会在进入   
	}, false);

	//
	repairRequest.submitForm = function() {
		//mui.confirm('MUI是个好框架，确认？', 'Hello MUI', btnArray, function (e) {
		//    if (e.index == 1) {
		//        info.innerText = '你刚确认MUI是个好框架';
		//    } else {
		//        info.innerText = 'MUI没有得到你的认可，继续加油'
		//    }
		//})

		//检查用户是否登陆
		if(window.localStorage.getItem(GlobalParas.CookieName.LoginUserID) == null) {
			mui.openWindow("..\User\LoginByTel.html");
			return false;
		}

		var ContentTitle = repairRequest.ContentTitle.value;
		var Description = repairRequest.Description.value;
		if(ContentTitle.length < 2) {
			mui.alert("请填写标题 ")
			return;
		}
		//没有选择图片就直接退出了
		if(repairRequest.files == null || repairRequest.files.length == 0) {
			mui.alert("请填写选择图片 ");
			return;
		}

		//有图片
		var urlUploadImg = GlobalParas.ServiceUrlRepair + "Service/TaskFileHandler.ashx";
		repairRequest.uploader = plus.uploader.createUpload(urlUploadImg, { //上传图片的委托
			method: 'POST',
			dataType: 'jsonp'
		}, function(upload, status) {
			//
			plus.nativeUI.closeWaiting();
			//mui.alert("upload status " + status + " cb:" + upload.responseText);
			if(status == 200) {
				mui.toast('文件上传成功~');
			} else {
				mui.toast('文件上传失败~');
				return;
			}

			var self = plus.webview.currentWebview();
			var fromPageId = self.fromPageId;

			if(fromPageId == null) {
				mui.back();
				return;
			}

			var lastPage = plus.webview.getWebviewById(fromPageId);
			if(lastPage == null) {
				mui.back();
				return;
			} else {

				mui.fire(lastPage, 'refreshFile', {
					from: 'add'
				}); //传递参数	 
				mui.currentWebview.close(); //必须销毁当前页面						
				lastPage.show();
				return;
			}
		});

		//添加上传文件
		mui.each(repairRequest.files, function(index, element) {
			var f = repairRequest.files[index];
			//mui.alert("addData:" + index + "," + f.name);
			// console.log("addFile:" + JSON.stringify(f));
			repairRequest.uploader.addFile(f.path, {
				key: f.name
			});
		});
		//参数
		repairRequest.uploader.addData("cmd", "AddRepairTaskFile");
		repairRequest.uploader.addData("FormID", " " + TaskFormID);
		repairRequest.uploader.addData("PortType", " "+GlobalParas.PortType);
		repairRequest.uploader.addData("SoftType", " "+GlobalParas.SoftType);
		repairRequest.uploader.addData("CorpID",   1);
		repairRequest.uploader.addData("UserID", " " + UserID);
		repairRequest.uploader.addData("ContentTitle", ContentTitle);
		repairRequest.uploader.addData("Description", Description);
		plus.nativeUI.showWaiting(); //显示等待框
		repairRequest.uploader.start(); //开始上传任务

	};

	repairRequest.finishOperate = function() {
		repairRequest.clearForm();
		mui.alert('提交成功!');
		mui.back();
		//      var detailPage = plus.webview.getWebviewById('Index4RepairMan');
		//		if(detailPage == null) {
		//			mui.openWindow("index.html");
		//			return;
		//		}
		//		else{		
		//			mui.fire(detailPage, 'refreshlist', {
		//				from: 'add'
		//			}); //传递参数	 
		//			mui.currentWebview.close();//必须销毁当前页面						
		// 			detailPage.show();	
		// 			return;
		//		}

	};

})();