(function () {
    var indexImage = 1;
    var size = null;
	var imageIndexIdNum = 0;
	
    var repairRequest = {
        ReplacePartInfo: document.getElementById('ReplacePartInfo'), 
        ImprovedFeedback: document.getElementById('ImprovedFeedback'), 
        ResultNote: document.getElementById('ResultNote'), 
      	imageList: document.getElementById('image-list'),
        submitbtn: document.getElementById('submitbtn')
    };

    repairRequest.files = [];
    repairRequest.uploader = null;
    repairRequest.deviceInfo = null;
	mui.plusReady(function() {
		//设备信息，无需修改
		repairRequest.deviceInfo = {
			appid: plus.runtime.appid,
			imei: plus.device.imei, //设备标识
			images: repairRequest.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: plus.runtime.version,
			plus_version: plus.runtime.innerVersion, //基座版本号
			os: mui.os.version,
			net: '' + plus.networkinfo.getCurrentType()
		}
	});
    /**
	 *提交成功之后，恢复表单项 
	 */
    repairRequest.clearForm = function () {
        repairRequest.ReplacePartInfo.value = '';
		repairRequest.imageList.innerHTML = '';
        indexImage = 0;
    };

	/**
	 *获取图片数量
	 */
	repairRequest.getFileInputArray = function() {
		return [].slice.call(repairRequest.imageList.querySelectorAll('.file'));
	};
	/**
	 *添加图片
	 */
	repairRequest.addFile = function(path) {
		repairRequest.files.push({
			name: "images" + indexImage,
			path: path
		});
		indexImage++;
	};
	/**
	 * 初始化图片域占位
	 */
	repairRequest.newPlaceholder = function() {
		var fileInputArray = repairRequest.getFileInputArray();
		if(fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var up = document.createElement("div");
		up.setAttribute('class', 'image-up')
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				repairRequest.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);

		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);

			plus.gallery.pick(function(e) {
				//console.log("event:"+e);
				var name = e.substr(e.lastIndexOf('/') + 1);
				//console.log("name:" + name);

				plus.zip.compressImage({
					src: e,
					dst: '_doc/' + name,
					overwrite: true,
					quality: 50
				}, function(zip) {
					size += zip.size
					//console.log("filesize:" + zip.size + ",totalsize:" + size);
					if(size > (6 * 1024 * 1024)) {
						return mui.toast('文件超大,请重新选择~,最大图片尺寸是6M');
					}
					if(!self.parentNode.classList.contains('space')) { //已有图片
						repairRequest.files.splice(index - 1, 1, {
							name: "images" + index,
							path: e
						});
					} else { //加号
						placeholder.classList.remove('space');
						repairRequest.addFile(zip.target);
						repairRequest.newPlaceholder();
					}
					up.classList.remove('image-up');
					placeholder.style.backgroundImage = 'url(' + zip.target + ')';
				}, function(zipe) {
					mui.toast('压缩失败！')
				});

			}, function(e) {
				mui.toast(e.message);
			}, {});
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		repairRequest.imageList.appendChild(placeholder);
	};
	repairRequest.newPlaceholder();
    /**
	 * 点击提交按钮
	 */
    repairRequest.submitbtn.addEventListener('tap', function (event) {  	 
 
        setTimeout(function(){repairRequest.submitForm();} ,200) ;//过一会在进入   
    }, false);

 
    //
    repairRequest.submitForm = function () {
    	var repairResult = $(".liRepairResult").val();
    	if(repairResult == null || repairResult==""){
    		mui.alert("请选择维修结果");
    		return;
    	}  	
    	var responsibleParty = $(".liResponsibleParty").val();
    	if(responsibleParty == null || responsibleParty==""){
    		mui.alert("请选择责任方");
    		return;
    	}
     	var operateMethod = $(".liOperateMethod").val();
    	if(operateMethod == null || operateMethod==""){
    		mui.alert("请选择处置方法");
    		return;
    	}   	
    	//mui.confirm('MUI是个好框架，确认？', 'Hello MUI', btnArray, function (e) {
        //    if (e.index == 1) {
        //        info.innerText = '你刚确认MUI是个好框架';
        //    } else {
        //        info.innerText = 'MUI没有得到你的认可，继续加油'
        //    }
        //});
 
        //检查用户是否登陆
        if (window.localStorage.getItem(GlobalParas.CookieName.LoginUserID) == null) {
            mui.openWindow("..\User\LoginByTel.html");
            return false;
        }

        var ReplacePartInfo = repairRequest.ReplacePartInfo.value;
        var ResultNote = repairRequest.ResultNote.value;
        var ImprovedFeedback = repairRequest.ImprovedFeedback.value;
  
		$.ajax({
			type: "GET",
			//async: false,
			crossDomain: true,
			cache: true,
			dataType: GlobalParas.AjaxDataType,
			timeout: 5000,
			jsonp: "callbackparam",
			contentType: "application/json;utf-8",
			url: GlobalParas.ServiceUrlRepair + "Service/Form4RepairmanDemoHandler.ashx",
			data: {
				cmd: "FinishRepairTaskForm",
				SoftType: GlobalParas.SoftType,
				PortType: GlobalParas.PortType,
				TaskFormID: TaskFormID,

				
				ProductResultStatus:repairResult,
				RepairResponsibleParty:responsibleParty,
				ProductOperateMethod:operateMethod,
				
				ResultOperateNote:ResultNote,
				ImprovedFeedback:ImprovedFeedback,
				ReplacePartInfo:ReplacePartInfo,
				
				CurrentUserID: window.localStorage.getItem(GlobalParas.CookieName.LoginUserID)	
			},
			success: function(data, status) {
				if(data.Status == "error" || data.Status == "exception") {
					alert("错误:" + data.Info);
					return;
				}

			 	repairRequest.uploadImages();			
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {//alert(XMLHttpRequest.status);
				//alert(XMLHttpRequest.readyState);
				//plus.nativeUI.closeWaiting();
				alert("Error: 222 " + textStatus);
			}
		});
 	};
 
 
    repairRequest.uploadImages = function () {
		//没有选择图片就直接退出了
		if(repairRequest.files == null || repairRequest.files.length == 0) {		
		 	repairRequest.finishOperate();
			return;
		}
				
		//有图片
		var urlUploadImg = GlobalParas.ServiceUrlRepair + "Service/TaskFileHandler.ashx";
		repairRequest.uploader = plus.uploader.createUpload(urlUploadImg, {//上传图片的委托
			method: 'POST',
			dataType: 'jsonp'
		}, function(upload, status) {
			//
			plus.nativeUI.closeWaiting();			 
			//mui.alert("upload status " + status + " cb:" + upload.responseText);
			if(status == 200) {		
				mui.toast('图片上传成功~');
				repairRequest.finishOperate();
				return;
			}
			else {
			 	mui.toast('图片上传失败~');
			 	repairRequest.finishOperate();
			}
		});

		//添加上传文件
		mui.each(repairRequest.files, function(index, element) {
			var f = repairRequest.files[index];
			//mui.alert("addData:" + index + "," + f.name);
			//console.log("addFile:" + JSON.stringify(f));
			repairRequest.uploader.addFile(f.path, {
				key: f.name
			});
		});
		//参数
		repairRequest.uploader.addData("cmd", "AddRepairTaskFile");
		repairRequest.uploader.addData("FormID", " "+TaskFormID);
		repairRequest.uploader.addData("PortType", " "+GlobalParas.PortType);
		repairRequest.uploader.addData("SoftType", " "+GlobalParas.SoftType);
		repairRequest.uploader.addData("CorpID",   1);
		repairRequest.uploader.addData("UserID", " "+ RepairUserID);//用维修员代替当前用户UserID  RepairUserID 		 	
		repairRequest.uploader.addData("ContentTitle", "维修完成结果");	
		repairRequest.uploader.addData("Description", "");				
		plus.nativeUI.showWaiting();//显示等待框
		repairRequest.uploader.start();//开始上传任务      
    };


	repairRequest.finishOperate = function(){
		repairRequest.clearForm();               
        mui.alert('提交成功!');
	 	var mainView = plus.webview.getWebviewById("RepairMan/index.html");
	 	if(mainView != null){
	 		mui.fire(mainView, "refreshlist",{
				from: 'finish'
			});	
	 	}
		mui.currentWebview.close(); //必须销毁当前页面	
		plus.webview.getLaunchWebview().show();      
 
 						 
 						
//      mui.back();
//      var detailPage = plus.webview.getWebviewById('Index4RepairMan');
//		if(detailPage == null) {
//			mui.openWindow("index.html");
//			return;
//		}
//		else{		
//			mui.fire(detailPage, 'refreshlist', {
//				from: 'add'
//			}); //传递参数	 
//			mui.currentWebview.close();//必须销毁当前页面						
// 			detailPage.show();	
// 			return;
//		}
		
	};

 
})();