(function() {
	var indexImage = 1;
	var urgencyLevel = 0;
	var size = null;
	var imageIndexIdNum = 0;
	var requestFormID = 0;
 
	//var fromPageType;
	var repairRequest = {
		corpName: document.getElementById('corpName'),
		productName: document.getElementById('productName'),
		partNO: document.getElementById('partNO'),
		imageList: document.getElementById('image-list')
	};

	repairRequest.files = [];
	repairRequest.uploader = null;
	repairRequest.deviceInfo = null;

	mui.plusReady(function() {

		//设备信息，无需修改
		repairRequest.deviceInfo = {
			appid: plus.runtime.appid,
			imei: plus.device.imei, //设备标识
			images: repairRequest.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: plus.runtime.version,
			plus_version: plus.runtime.innerVersion, //基座版本号
			os: mui.os.version,
			net: '' + plus.networkinfo.getCurrentType()
		}

		/**
		 * 点击提交按钮
		 */
		document.getElementById('submitProblemForm1').addEventListener('tap', function(event) {
			mui('#submitPopover').popover('hide'); //先隐藏弹出框
			setTimeout(function() {
				repairRequest.submitForm(1);
			}, 200); //过一会在进入   
		}, false);

		document.getElementById('submitProblemForm2').addEventListener('tap', function(event) {
			mui('#submitPopover').popover('hide'); //先隐藏弹出框
			setTimeout(function() {
				repairRequest.submitForm(2);
			}, 200); //过一会在进入
		}, false);

		document.getElementById('deleteProblemForm').addEventListener('tap', function(event) {
			mui('#submitPopover').popover('hide'); //先隐藏弹出框
			setTimeout(function() {
				repairRequest.deleteForm();
			}, 200); //过一会在进入
		}, false);

		var self = plus.webview.currentWebview();
		requestFormID = self.requestid;
		//alert(requestFormID)
		if(requestFormID == null) {
			mui.back();
			return;
		}

		repairRequest.InitialImage();

		repairRequest.initialRequestFrm();
	});

	repairRequest.initialRequestFrm = function() {
 
		$.ajax({
			type: "GET",
			//async: false,
			crossDomain: true,
			cache: false,
			timeout: 5000,
			dataType: "jsonp", //跨域
			timeout: 5000,
			jsonp: "callbackparam",
			contentType: "application/json;utf-8",
			url: GlobalParas.ServiceUrlRepair + "Service/Form4ReportmanHandler.ashx",
			data: {
				cmd: "Get4Edit",
				ID: requestFormID,
				SoftType: GlobalParas.SoftType,
				PortType: GlobalParas.PortType,
				IsDemo:true
			},
			success: function(data, status) {
				if(data.Status == "error" || data.Status == "exception") {
					alert("错误:" + data.Info);
					mui.back();
					return;
				}

				requestEntity = data;
				
				document.getElementById('questionCode').value = requestEntity.ProblemDescription;	
				document.getElementById('OtherDescription').value = requestEntity.OtherDescription;
				document.getElementById('productName').value = requestEntity.ProductName;
				document.getElementById('corpName').value = "上海义维流体科技有限公司(演示)";//requestEntity.CorpName;
				document.getElementById('buyTime').value = requestEntity.BuyTime;		
				document.getElementById('partNO').value = requestEntity.PartNO;
				document.getElementById('productAddress').value = requestEntity.LocationAdress;
				
				//质保期内
				if(requestEntity.ProductInfo.indexOf("ZBQ:0")>=0){
					var boxes = document.getElementById("isZBQ");
					boxes.checked = false;
				}
				//
				selProductID = requestEntity.ProductID;
				urgencyLevel = requestEntity.UrgencyLevel;

				if(requestEntity.FormStatus == 0) {
					$("#deleteProblemForm").show();
				} else if(requestEntity.FormStatus == 1) {
					$("#deleteProblemForm").show();
					$("#submitProblemForm2").hide();
				} else {
					$("#deleteProblemForm").hide();
					$("#submitProblemForm2").hide();
				}
				mui('.icons i').each(function(index, element) {
					if(index < requestEntity.UrgencyLevel) {
						element.classList.remove('mui-icon-star');
						element.classList.add('mui-icon-star-filled');
					}
				});
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				//alert(XMLHttpRequest.status);
				//alert(XMLHttpRequest.readyState);
				//plus.nativeUI.closeWaiting();
				alert("Error: 128 " + textStatus);
			}
		});

	}
	/**
	 *提交成功之后，恢复表单项 
	 */
	repairRequest.clearForm = function() {
		repairRequest.imageList.innerHTML = '';
		repairRequest.productName.value = '';
		repairRequest.partNO.value = '';

		indexImage = 0;
		urgencyLevel = 0;
		//清除所有星标
		mui('.icons i').each(function(index, element) {
			if(element.classList.contains('mui-icon-star-filled')) {
				element.classList.add('mui-icon-star')
				element.classList.remove('mui-icon-star-filled')
			}
		});
	};

	/**
	 *获取图片数量
	 */
	repairRequest.getFileInputArray = function() {
		return [].slice.call(repairRequest.imageList.querySelectorAll('.file'));
	};

	/**
	 *添加图片
	 */
	repairRequest.addFile = function(path) {
		repairRequest.files.push({
			name: "images" + indexImage,
			path: path
		});
		indexImage++;
	};
	/**
	 * 初始化图片域占位
	 */
	repairRequest.newPlaceholder = function() {
		var fileInputArray = repairRequest.getFileInputArray();
		if(fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');

		var picture1 = document.createElement('div');
		var up = document.createElement("div");
		up.setAttribute('class', 'image-up')
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.index = indexImage;
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			for(var i = 0; i < repairRequest.files.length; i++) {
				//console.log(repairRequest.files[i].name);
				if(repairRequest.files[i].name == ("images" + this.index)) {
					repairRequest.files.splice(i, 1);
				}
			}
			setTimeout(function() {
				repairRequest.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);

		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);
			repairRequest.sheet('选择照片', ['拍照', '相册'], function(ev) {//, '录像', '录音'
				var typeindex = ev.index;
				var imagefile;
				if(typeindex == 1) {
										 if(mui.os.android) {

					 } else {
					 	var btnArray = ['否', '是'];
					 	mui.confirm('我们需要访问您的相机拍照片，请确认？', '提示', btnArray, function(e) {
					 		if(e.index == 0) {
					 			return;
					 		}
					 	});
					 }
					 
					var c = plus.camera.getCamera();
					c.captureImage(function(e) {
						//console.log("event:"+e);
						var name = e.substr(e.lastIndexOf('/') + 1);
						//console.log("name:" + name);
						plus.zip.compressImage({
							src: e,
							dst: '_doc/' + name,
							overwrite: true,
							quality: 50
						}, function(zip) {
							size += zip.size
							//console.log("filesize:" + zip.size + ",totalsize:" + size);
							if(size > (6 * 1024 * 1024)) {
								return mui.toast('文件超大,请重新选择~,最大图片尺寸是6M');
							}
							if(!self.parentNode.classList.contains('space')) { //已有图片
								repairRequest.files.splice(index - 1, 1, {
									name: "images" + index,
									path: e
								});
							} else { //加号
								placeholder.classList.remove('space');
								repairRequest.addFile(zip.target);
								repairRequest.newPlaceholder();
							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(' + zip.target + ')';
						}, function(zipe) {
							mui.toast('压缩失败！')
						});
					}, function(s) {
						console.log("error" + s);
					}, {
						filename: "_doc/head.png"
					})

				} else if(typeindex == 2) {
										if(mui.os.android) {

					 } else {
					 	var btnArray = ['否', '是'];
					 	mui.confirm('我们需要访问您的相册，请确认？', '提示', btnArray, function(e) {
					 		if(e.index == 0) {
					 			return;
					 		}
					 	});
					 }
					 
					plus.gallery.pick(function(e) {
						//console.log("event:"+e);
						var name = e.substr(e.lastIndexOf('/') + 1);
						//console.log("name:" + name);
						plus.zip.compressImage({
							src: e,
							dst: '_doc/' + name,
							overwrite: true,
							quality: 50
						}, function(zip) {
							size += zip.size
							//console.log("filesize:" + zip.size + ",totalsize:" + size);
							if(size > (6 * 1024 * 1024)) {
								return mui.toast('文件超大,请重新选择~,最大图片尺寸是6M');
							}
							if(!self.parentNode.classList.contains('space')) { //已有图片
								repairRequest.files.splice(index - 1, 1, {
									name: "images" + index,
									path: e
								});
							} else { //加号
								placeholder.classList.remove('space');
								repairRequest.addFile(zip.target);
								repairRequest.newPlaceholder();
							}
							up.classList.remove('image-up');
							placeholder.style.backgroundImage = 'url(' + zip.target + ')';
						}, function(zipe) {
							mui.toast('压缩失败！')
						});
					}, function(e) {
						//mui.toast(e.message);
					}, {});

				} else if(typeindex == 3) {

					var File = plus.android.importClass("java.io.File");
					var Uri = plus.android.importClass("android.net.Uri");
					var MediaStore = plus.android.importClass("android.provider.MediaStore");
					var Intent = plus.android.importClass("android.content.Intent");
					var intent = new Intent(MediaStore.ACTION_VIDEO_CAPTURE);
					intent.putExtra(MediaStore.EXTRA_VIDEO_QUALITY, 0); //0 最低质量, 1高质量MediaStore.EXTRA_SIZE_LIMIT
					intent.putExtra(MediaStore.EXTRA_DURATION_LIMIT, 10);
					var main = plus.android.runtimeMainActivity();
					main.startActivityForResult(intent, 1);
					main.onActivityResult = function(request, code, data) {

						if(request == 1001) { //相册Activity返回码

						} else {
							alert("需要选择");
							plus.gallery.pick(function(path) {

								if(!self.parentNode.classList.contains('space')) { //已有
									repairRequest.files.splice(index - 1, 1, {
										name: "images" + index,
										path: path
									});
								} else { //加号
									placeholder.classList.remove('space');
									repairRequest.addFile(path, 1);
									repairRequest.newPlaceholder();

								}
								$(self).remove();
								//							fileInput.removeEventListener("tap");
								//							fileInput.preventDefault();
								up.classList.remove('image-up');
								picture1.setAttribute('style', 'background-image:url(../Repair/images/Video.png);height:65px;width:65px;background-size:100% 100%');

								var url = path;
								picture1.addEventListener("tap", function() {

									judgePlatform(url);
								})

							}, function(e) {
								//console.log("取消选择视频");
							}, {
								filter: "video" //筛选类型
							});
						}
					}

				} else if(typeindex == 4) {

					var r = plus.audio.getRecorder();
					if(r == null) {
						console.log("录音对象未获取");
						return;
					}
					r.record({
						filename: "_doc/audio/"
					}, function(p) {
						if(r != null){
							clearInterval(r);
							r = null;
						}
							
						plus.io.resolveLocalFileSystemURL(p, function(entry) {
							var path = entry.toLocalURL();
							if(!self.parentNode.classList.contains('space')) { //已有
								repairRequest.files.splice(index - 1, 1, {
									name: "images" + index,
									path: path
								});
							} else { //加号
								placeholder.classList.remove('space');
								repairRequest.addFile(path, 2);
								repairRequest.newPlaceholder();
							}
							$(self).remove();

							up.classList.remove('image-up');
							picture1.setAttribute('style', 'background-image:url(../Repair/images/Voice.png);height:65px;width:65px;background-size:100% 100%');
							picture1.url = p;

							picture1.addEventListener("tap", function() {
								//showPlayer(this.url);
								startPlay(this.url);
							})

							//console.log(entry.toLocalURL());
						}, function(e) {
							console.log("读取录音文件错误：" + e.message);
						});
					}, function(e) {
						console.log("录音失败：" + e.message);
					});
					er.style.display = "block";
					t = 0;
					r = setInterval(function() {
						t++;
						rt.innerText = timeToStr(t);
					}, 1000);

				}

			});

		}, false);

		placeholder.appendChild(picture1);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		repairRequest.imageList.appendChild(placeholder);
	};

	repairRequest.newPlaceholder();
	repairRequest.sheet = function(title, btns, func) {
		if(title && btns && btns.length > 0) {
			var btnArray = [];
			for(var i = 0; i < btns.length; i++) {
				btnArray.push({
					title: btns[i]
				});
			}

			plus.nativeUI.actionSheet({
				title: title,
				cancel: '取消',
				buttons: btnArray
			}, function(e) {
				if(func) func(e);
			});
		}
	};

	//
	repairRequest.InitialImage = function() {

		$.ajax({
			type: "GET",
			async: true,
			crossDomain: true,
			cache: false,
			contentType: "application/json;utf-8",
			dataType: GlobalParas.AjaxDataType,
			jsonp: "callbackparam",
			url: GlobalParas.ServiceUrlRepair + "Service/RequestFileHandler.ashx",
			data: {
				cmd: "GetRequestFile",
				SoftType: GlobalParas.SoftType,
				PortType: GlobalParas.PortType,
				IsDemo:true,
				FormID: requestFormID,
				UserID: window.localStorage.getItem(GlobalParas.CookieName.LoginUserID)
			},
			success: function(result) {

				if(result == null)
					return;
				if(result.Status == "error" || result.Status == "exception") {
					mui.alert(result.Info);
					return;
				}

				for(var i = 0; i < result.length; i++) {
					//console.log(result[i].FilePath);
					//result[i].FileType
					var picture = document.createElement('div');
					var picture1 = document.createElement('div');

					if(result[i].FileType == 0) {
						picture.setAttribute('class', 'image-item');
						picture1.setAttribute('style', 'background-image:url(' + GlobalParas.ServiceUrlRepair + "RepairRequestFile/" + result[i].ThumbnailFile + ');height:65px;width:65px;background-size:100% 100%');

						picture.setAttribute('name', result[i].ID);
					} else if(result[i].FileType == 1) {
						picture.setAttribute('class', 'image-item');
					
						picture1.setAttribute('style', 'background-image:url(../Repair/images/Video.png);height:65px;width:65px;background-size:100% 100%');

						picture.setAttribute('name', result[i].ID);
						picture1.videourl = GlobalParas.ServiceUrlRepair + "RepairRequestFile/" + result[i].FilePath;
						picture1.flieName = result[i].FilePath;
						picture1.addEventListener("tap", function() {
					
							getdownloadRadio(this.videourl, this.flieName);
							//judgePlatform(this.videourl,this.flieName);
						})
					} else if(result[i].FileType == 2) {
						picture.setAttribute('class', 'image-item');
						picture1.setAttribute('style', 'background-image:url(../Repair/images/Voice.png);height:65px;width:65px;background-size:100% 100%');

						picture.setAttribute('name', result[i].ID);
						picture1.videourl = GlobalParas.ServiceUrlRepair + "RepairRequestFile/" + result[i].FilePath;
						picture1.flieName = result[i].FilePath;
						picture1.addEventListener("tap", function() {
				
							getdownloadRecord(this.videourl, this.flieName);
							//judgePlatform(this.videourl,this.flieName);
						})
					}

					var closeButton = document.createElement('div');
					closeButton.setAttribute('class', 'image-close');
					closeButton.innerHTML = 'X';
					//小X的点击事件
					closeButton.addEventListener('tap', function(event) {
						event.preventDefault();

						var deleteBtn = $(this);
						var fileID = deleteBtn.parent().attr("name");

						var btnArray = ['取消', '确认删除'];
						mui.confirm('请问是否删除，确认？', '确认删除', btnArray, function(e) {
							if(e.index == 1) {

								repairRequest.deleteImg(fileID);
								deleteBtn.parent().remove();
								return;
							} else {
								return;
							}
						});
					}, false);
					
				 
					picture.appendChild(picture1);
					picture.appendChild(closeButton);

					$("#image-list").prepend(picture);

				}
			},
			error: function(err) {
				mui.alert("失败！ERROR:" + err);
			}
		});

	};
	//删除已经上传的图片
	repairRequest.deleteImg = function(fileID) {
		$.ajax({
			type: "GET",
			async: true,
			crossDomain: true,
			cache: false,
			contentType: "application/json;utf-8",
			dataType: GlobalParas.AjaxDataType,
			jsonp: "callbackparam",
			url: GlobalParas.ServiceUrlRepair + "Service/RequestFileHandler.ashx",
			data: {
				cmd: "DeleteFile",
				SoftType: GlobalParas.SoftType,
				PortType: GlobalParas.PortType,
				IsDemo:true,
				From: GlobalParas.SoftType,
				FileID: fileID
			},
			success: function(result) {
				if(result == null)
					return;
				if(result.Status == "error" || result.Status == "exception") {
					mui.alert(result.Info);
					return;
				}

				mui.alert("删除成功");
			}
		});

	}

	//
	repairRequest.deleteForm = function() {

		var btnArray = ['取消', '确认删除'];
		mui.confirm('请问是否删除此表单，确认？', '确认删除', btnArray, function(e) {

			if(e.index == 1) {

				$.ajax({
					type: "GET",
					async: true,
					crossDomain: true,
					cache: false,
					contentType: "application/json;utf-8",
					dataType: GlobalParas.AjaxDataType,
					jsonp: "callbackparam",
					url: GlobalParas.ServiceUrlRepair + "Service/Form4ReportmanHandler.ashx",
					data: {
						cmd: "DeleteRequest",
						SoftType: GlobalParas.SoftType,
						PortType: GlobalParas.PortType,
						IsDemo:true,
						ID: requestEntity.ID,
						CustomerUserID: window.localStorage.getItem(GlobalParas.CookieName.LoginUserID)
					},
					success: function(result) {
						if(result == null)
							return;
						if(result.Status == "error" || result.Status == "exception") {
							mui.alert(result.Info);
							return;
						}
						//alert(result.Info);
						repairRequest.finishOperate();
						mui.alert("删除成功");

					},
					error: function(err) {
						mui.alert("删除失败！ERROR:" + err);
					}
				});

				return;
			} else {
				return;
			}
		});

	};

	//
	repairRequest.submitForm = function(index) {		
		var ProductInfo ="";
		 if($("#isZBQ").is(':checked')){
		 	ProductInfo="ZBQ:1";
		 }
		 else{
		 	ProductInfo="ZBQ:0";
		 }
 
		var productName = document.getElementById('productName').value;
		if(productName.length < 2) {
			return mui.toast('请选择型号~');
		}
		if(selProductID <= 0) {//selProductID == 0 表示库里面没有此产品
			selProductID = requestEntity.ProductID;
		}
		//
		var locationAdress = $("#productAddress").val();
		if(locationAdress.length < 5) {
			return mui.toast('请填写位置')
		}
		var locationPosi="";
		if(mapPointLng != null && mapPointLng != "" && mapPointLat != null && mapPointLat != ""){
			locationPosi = mapPointLng + ","+mapPointLat;
		}		
		else{
			locationPosi = requestEntity.LocationPosi;
		}
 
		/*var corpName = repairRequest.corpName.value;
		if(corpName.length < 4) {
			viewApi.go('#divMainForm1');
			return mui.toast('请填写设备厂家')
		}
		if(selFactoryID<0 || selCorpID<0 && requestEntity.CorpID.length>1){
			var ids= requestEntity.CorpID.split("-");
 			selCorpID=ids[0];			
 			selFactoryID=ids[1];
		}	*/	
 
		$.ajax({
			type: "GET",
			async: true,
			crossDomain: true,
			cache: false,
			contentType: "application/json;utf-8",
			dataType: GlobalParas.AjaxDataType,
			jsonp: "callbackparam",
			url: GlobalParas.ServiceUrlRepair + "Service/Form4ReportmanHandler.ashx",
			data: {
				cmd: "EditRequest4App",
				SoftType: GlobalParas.SoftType,
				PortType: GlobalParas.PortType,
				IsDemo:true,	
				ID: requestEntity.ID,
				ProductName: productName,
				ProductID: selProductID,
			 	OtherDescription: document.getElementById('OtherDescription').value,
				PartNO: document.getElementById('partNO').value,
				UrgencyLevel: urgencyLevel,
				ProblemCode: requestEntity.ProblemCode,
				LocationAdress:	locationAdress,
				LocationPosi: locationPosi,
				IsSubmit: index,
				BuyTime: document.getElementById('buyTime').value,
 				ProductInfo:ProductInfo,
				UserID: window.localStorage.getItem(GlobalParas.CookieName.LoginUserID)
			},
			success: function(result) {
			 
				if(result == null)
					return;
				if(result.Status == "error" || result.Status == "exception") {
					mui.alert(result.Info);
					return;
				}
				if(index == 1){
					mui.alert('保存成功,注意当前表单并未提供,等待您确认后提交!');
				}
				else{
					mui.alert('提交成功,注意当前是 演示版,并不会真正有人为您进行维修服务!');
				}
		

				//没有选择图片就直接退出了
				if(repairRequest.files == null || repairRequest.files.length == 0) {
					repairRequest.finishOperate();
					return;
				};
				//alert(requestFormID);
				mui.toast('开始上传文件~');
				//有图片
				var urlUploadImg = GlobalParas.ServiceUrlRepair + "Service/RequestFileHandler.ashx";
				repairRequest.uploader = plus.uploader.createUpload(urlUploadImg, { //上传图片的委托
					method: 'POST',
					dataType: GlobalParas.AjaxDataType
				}, function(upload, status) {
					//
					plus.nativeUI.closeWaiting();
					repairRequest.finishOperate();
					//mui.alert("upload status " + status + " cb:" + upload.responseText);
					if(status == 200) {
						mui.toast('文件上传成功~');

						return;
						//
						//console.log("upload success");
						//						repairRequest.clearForm();
						//						mui.alert("报修已提交，我们会尽快和您联系，点击确定关闭2", "问题报修", "确定", function() {
						//							mui.back();
						//						});
					} else {
						mui.toast('文件上传失败~');
					}
				});

				//添加上传文件
				mui.each(repairRequest.files, function(index, element) {
					var f = repairRequest.files[index];
					//mui.alert("addData:" + index + "," + f.name);
					// console.log("addFile:" + JSON.stringify(f));
					repairRequest.uploader.addFile(f.path, {
						key: f.name
					});
				});
				//参数
				repairRequest.uploader.addData("cmd", "AddRequestFile");
				repairRequest.uploader.addData("FormID", " " + requestFormID);
				repairRequest.uploader.addData("SoftType", GlobalParas.SoftType);
				plus.nativeUI.showWaiting(); //显示等待框
				repairRequest.uploader.start(); //开始上传任务
			},
			error: function(err) {
				mui.alert("提交失败！ERROR:" + err);
			}
		});

	};

	//
	repairRequest.finishOperate = function() {
		var detailPage = plus.webview.getWebviewById('RepairReport/index.html');
		if(detailPage == null) {
			plus.webview.getLaunchWebview().show(); 
			return;
		} else {
			mui.fire(detailPage, 'refreshlist', {
				from: 'edit'
			}); //传递参数	 
			mui.currentWebview.close(); //必须销毁当前页面						
			plus.webview.getLaunchWebview().show(); 
			return;
		}

	};
	//紧急程度
	mui('.icons').on('tap', 'i', function() {
		var index = parseInt(this.getAttribute("data-index"));
		var parent = this.parentNode;
		var children = parent.children;
		if(this.classList.contains("mui-icon-star")) {
			for(var i = 0; i < index; i++) {
				children[i].classList.remove('mui-icon-star');
				children[i].classList.add('mui-icon-star-filled');
			}
		} else {
			for(var i = index; i < 3; i++) {
				children[i].classList.add('mui-icon-star')
				children[i].classList.remove('mui-icon-star-filled')
			}
		}
		urgencyLevel = index;
	});
})();

function startGeoLocByMap() {
	map.plugin('AMap.Geolocation', function() {
		geolocation = new AMap.Geolocation({
			enableHighAccuracy: true, //是否使用高精度定位，默认:true
			timeout: 10000, //超过10秒后停止定位，默认：无穷大
			buttonOffset: new AMap.Pixel(10, 20), //定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
			zoomToAccuracy: true, //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
			buttonPosition: 'RB'
		});
		map.addControl(geolocation);
		geolocation.getCurrentPosition();

		AMap.event.addListener(geolocation, 'complete', onLocByMapComplete); //返回定位信息
		AMap.event.addListener(geolocation, 'error', onLocByMapError); //返回定位出错信息
	});

}

//解析定位结果
var marker;

function onLocByMapComplete(data) {
	map.clearMap()
	marker = new AMap.Marker({
		icon: "https://webapi.amap.com/theme/v1.3/markers/n/mark_b.png",
		position: [data.position.getLng(), data.position.getLat()]
	});
	marker.setMap(map);
	marker.setDraggable(true);
	//				var str = ['定位成功'];
	//				str.push('经度：' + data.position.getLng());
	//				str.push('纬度：' + data.position.getLat());
	//				if(data.accuracy) {
	//					str.push('精度：' + data.accuracy + ' 米');
	//				} //如为IP精确定位结果则没有精度信息
	//				str.push('是否经过偏移：' + (data.isConverted ? '是' : '否'));
	//alert(str.join('<br>'));
}
//解析定位错误信息
function onLocByMapError(data) {
	alert('定位失败,请开启GPRS定位');
}
//获取定位点信息
function getPosiByMap() {
	var p = marker.getPosition();
	mapPointLng = p.getLng();
	mapPointLat = p.getLat();
	var geocoder = new AMap.Geocoder({});
	geocoder.getAddress(p, function(status, result) {
		if(status === 'complete' && result.info === 'OK') {
			var address = result.regeocode.formattedAddress;
			$("#productAddress").val(address);
		}
	});
}
//设置地图位置
function setMapLocation(lng,lat) {
	     marker = new AMap.Marker({
            icon: "https://webapi.amap.com/theme/v1.3/markers/n/mark_b.png",
            position: [lng, lat]
        });
        marker.setMap(map);
        marker.setDraggable(true);
        var lnglat = new AMap.LngLat(lng, lat)
        map.setCenter(lnglat)
        
}