var isShowLeftMenu = false;
var leftMenuDIspMode = 'main-move';
var mainView, menuView;//主窗口和侧边窗口
var maskView = mui.createMask(_closeMenu);
		

//重写mui.menu方法，Android版本menu按键按下可自动打开、关闭侧滑菜单；
mui.menu = function() {
	if(isShowLeftMenu) {
		closeMenu();
	} else {
		openMenu();
	}
}

function InitialLeftMenu() {
	//plusReady事件后，自动创建menu窗口；
	mainView = plus.webview.currentWebview();

	//setTimeout的目的是等待窗体动画结束后，再执行create webview操作，避免资源竞争，导致窗口动画不流畅；
	setTimeout(function() {
		//侧滑菜单默认隐藏，这样可以节省内存；
		menuView = mui.preload({
			id: 'MainIndexLeftMenu',
			url: 'IndexLeftMenu.html',
			styles: {
				left: 0,
				width: '70%',
				zindex: 9997
			}
		});
	}, 300);

	//整体滑动暂不支持android手机，因为两个页面的移动动画，无法保证同步性；
//	if(!mui.os.android) {
//		//整体滑动暂不支持android手机，因为两个页面的移动动画，无法保证同步性；
//		document.getElementById("move-togger").classList.remove('mui-hidden');
//		var spans = document.querySelectorAll('.android-only');
//		for(var i = 0, len = spans.length; i < len; i++) {
//			spans[i].style.display = "none";
//		}
//	}
	//点击左上角图标，打开侧滑菜单；
	document.querySelector('.mui-icon-bars').addEventListener('tap', openMenu);

	//在android4.4中的swipe事件，需要preventDefault一下，否则触发不正常
	//故，在dragleft，dragright中preventDefault
	window.addEventListener('dragright', function(e) {
		e.detail.gesture.preventDefault();
	});
	window.addEventListener('dragleft', function(e) {
		e.detail.gesture.preventDefault();
	});
	//主界面向右滑动，若菜单未显示，则显示菜单；否则不做任何操作；
	window.addEventListener("swiperight", openMenu);
	//主界面向左滑动，若菜单已显示，则关闭菜单；否则，不做任何操作；
	window.addEventListener("swipeleft", closeMenu);
	window.addEventListener("closeMenu", closeMenu);	
	//menu页面向左滑动，关闭菜单；
	window.addEventListener("menuView:swipeleft", closeMenu);
	
	//
	window.addEventListener("menuView:openFavoritPage", openFavoritPage);	
	
	//
	window.addEventListener("menuView:openBrowerHistory", openBrowerHistory);	
	
	//
	window.addEventListener("menuView:openCusomterList", openCusomterList);		
}
function openFavoritPage() {
	closeMenu();
	var detailPage = plus.webview.getWebviewById('MyFavoritesList');
	//alert(detailPage);//每次都是null不知道为啥
	if(detailPage == null) {
		mui.openWindow({
			url: 'MyFavoritesList.html',
			id: 'MyFavoritesList',
			extras: {
				from: 'index'
			}
		});
	} else {
		detailPage.show();
	}
}
function openBrowerHistory() {
	closeMenu();
	var detailPage = plus.webview.getWebviewById('MyBrowerHisory');
	//alert(detailPage);//每次都是null不知道为啥
	if(detailPage == null) {
		mui.openWindow({
			url: 'MyBrowerHisory.html',
			id: 'MyBrowerHisory',
			extras: {
				from: 'index'
			}
		});
	} else {
		detailPage.show();
	}
}
function openCusomterList(){
    mui.openWindow({
        url: '../about/spumpCusomterList.html',
        id: 'CustomerList',
        extras: {
            from: 'index'
        }
    });	
}
/**
 * 显示菜单菜单
 */
function openMenu() {
	if(!isShowLeftMenu) {
		//侧滑菜单处于隐藏状态，则立即显示出来；
		//显示完毕后，根据不同动画效果移动窗体；
		menuView.show('none', 0, function() {
			switch(leftMenuDIspMode) {
				case 'main-move':
					//主窗体开始侧滑；
					mainView.setStyle({
						left: '70%',
						transition: {
							duration: 150
						}
					});
					break;
				case 'menu-move':
					menuView.setStyle({
						left: '30%',
						transition: {
							duration: 150
						}
					});
					break;
				case 'all-move':
					mainView.setStyle({
						left: '70%',
						transition: {
							duration: 150
						}
					});
					menuView.setStyle({
						left: '0%',
						transition: {
							duration: 150
						}
					});
					break;
			}
		});
		//显示遮罩
		maskView.show();
		isShowLeftMenu = true;
	}
}
/**
 * 关闭侧滑菜单
 */
function closeMenu() {

	_closeMenu();

	//关闭遮罩
	maskView.close();
}

/**
 * 关闭侧滑菜单（业务部分）
 */
function _closeMenu() {
	if(isShowLeftMenu) {
		//关闭遮罩；
		switch(leftMenuDIspMode) {
			case 'main-move':
				//主窗体开始侧滑；
				mainView.setStyle({
					left: '0',
					transition: {
						duration: 150
					}
				});
				break;
			case 'menu-move':
				//主窗体开始侧滑；
				menuView.setStyle({
					left: '-70%',
					transition: {
						duration: 150
					}
				});
				break;
			case 'all-move':
				//主窗体开始侧滑；
				mainView.setStyle({
					left: '0',
					transition: {
						duration: 150
					}
				});
				//menu页面同时移动
				menuView.setStyle({
					left: '-70%',
					transition: {
						duration: 150
					}
				});

				break;
		}

		//等窗体动画结束后，隐藏菜单webview，节省资源；
		setTimeout(function() {
			menuView.hide();
		}, 200);
		//改变标志位
		isShowLeftMenu = false;
	}
}