﻿
var LxpFeatChart4Mobile = function () {
    var m_svg = null;
    var m_chartType = 1;//Speed 0     Cut 1     BaoLuo 2    ZhouLiu 4
    var m_pumpInfo;//泵参数
    var m_wrkCurveGrp4Pixel;//工作曲线
    var m_displayStyle;//显示样式
    var m_chartSize;
    var m_localizationType = 0;//中文zhCN = 0, zhTW = 1,   enUS = 2
    var m_divChartName;//容器DIV名称
    var m_coordinatePara;//坐标信息
    var m_chartObject;//图表上的物体
    var m_systemPlantType = 1;  //0: 电脑 1:手机  
    var m_isDispMiniTick = true;//是否显示子刻度
    var m_MiniTickNumber = 1;
    var m_isDispNpsh = true;//是否显示NPSH汽蚀
    var m_toolTipContent = null;
    var m_equipZeroH = 0;//装置曲线静扬程
    var m_isRotateLabelX = false;//是否旋转X坐标,过密时使用
    var m_isOutletPressReplaceH = false;//用出口压力MPa代替扬程H
    var m_unitQ = 1;//LS 0  M3H 1
    var m_isDispCurveQE = true;//显示效率线
    var m_designPointTolerance = [0.91, 1.09, 0.95, 1.05];//设计点公差
    //
    var valueFormat = function (value) {
        var v = value.toString();
        var result = v;
        var decimalIndex = v.indexOf('.');
        if (decimalIndex != -1) {
            result = v.substring(decimalIndex + 1, v.length);
            if (result.length > 3) {
                v = parseFloat(value).toFixed("3");
                var str = v.toString();
                if (str.substr(str.length - 2, 2) == "00") {
                    v = parseFloat(value).toFixed("1");
                }
                else if (str.substr(str.length - 1, 1) == "0") {
                    v = parseFloat(value).toFixed("2");
                }
            }
        }
        return v;
    };

    //转成Bezier曲线模型
    var transBezierCurveModel = function (pixelPoints) {
        if (pixelPoints == null || pixelPoints.length < 4)
            return null;

        var iPointCout = pixelPoints.length;
        var a = 0.09;
        var b = 0.09;
        var controlPoint = new Array();

        for (var i = 0; i < iPointCout - 1; i++) {
            var bezier = {};
            bezier.Point0 = pixelPoints[i];
            if (i == 0) {
                var x1 = pixelPoints[i].X + a * (pixelPoints[i + 1].X - pixelPoints[i].X);
                var y1 = pixelPoints[i].Y + a * (pixelPoints[i + 1].Y - pixelPoints[i].Y);
                bezier.Point1 = {
                    "X": x1,
                    "Y": y1
                };
            }
            else {
                var x1 = pixelPoints[i].X + a * (pixelPoints[i + 1].X - pixelPoints[i - 1].X);
                var y1 = pixelPoints[i].Y + a * (pixelPoints[i + 1].Y - pixelPoints[i - 1].Y);
                bezier.Point1 = {
                    "X": x1,
                    "Y": y1
                }
            }

            if (i == iPointCout - 2) {
                var x2 = pixelPoints[i + 1].X - b * (pixelPoints[i + 1].X - pixelPoints[i].X);
                var y2 = pixelPoints[i + 1].Y - b * (pixelPoints[i + 1].Y - pixelPoints[i].Y);
                bezier.Point2 = {
                    "X": x2,
                    "Y": y2
                }
            }
            else {
                var x2 = pixelPoints[i + 1].X - b * (pixelPoints[i + 2].X - pixelPoints[i].X);
                var y2 = pixelPoints[i + 1].Y - b * (pixelPoints[i + 2].Y - pixelPoints[i].Y);
                bezier.Point2 = {
                    "X": x2,
                    "Y": y2
                }
            }

            bezier.Point3 = pixelPoints[i + 1];
            controlPoint.push(bezier);
        }
        return controlPoint;
    };

    //转成曲线路径
    var transBezierCurveToPath = function (pixelPoints) {
        var bezierCurveValue = transBezierCurveModel(pixelPoints);
        if (bezierCurveValue == null) {
            return;
        }
        var pathValue = new Array();
        for (var h = 0; h < bezierCurveValue.length; h++) {
            if (h == 0) {
                pathValue.push("M ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
                pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            }
            else {
                pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
                pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            }
            if (h == bezierCurveValue.length - 1) {
                pathValue.push(" L ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            }
        }
        return pathValue;
    };

    var getActualValue = function (actualMinValue, actualMaxValue, pixelMinValue, pixelMaxValue, pixelValue) {
        var actual = null;
        actual = (pixelValue - pixelMinValue) / (pixelMaxValue - pixelMinValue) * (actualMaxValue - actualMinValue) + actualMinValue;
        // actual = (pixelValue - pixelMinValue) / (pixelMaxValue - pixelMinValue) * (actualMaxValue - actualMinValue) + pixelMinValue;
        return actual;
    };

    var getPixelValue = function (actualValue, actualMinValue, actualMaxValue, pixelMinValue, pixelMaxValue) {
        return (actualValue - actualMinValue) / (actualMaxValue - actualMinValue) * (pixelMaxValue - pixelMinValue) + pixelMinValue;
    };

    var getSectPoint4Pixel = function (curve, x) {

        var iPtCount = curve.length;

        if (x < curve[0].Point0.X) {
            return null;
        }
        if (x > curve[iPtCount - 1].Point3.X) {
            return null;
        }

        for (var i = 0; i < iPtCount; i++) {

            if (x > curve[i].Point0.X && x < curve[i].Point3.X) {
                var ptBizer = curve[i];
                //
                try {
                    //alert(i);
                    var minDis = Math.abs(ptBizer.Point3.X - ptBizer.Point0.X);
                    //alert(x + "   " + curve[i].Point0.X + "    " + curve[i].Point3.X);
                    var sectY = 0;
                    var sectX = 0;
                    for (var uu = 0; uu <= 1; uu = uu + 0.05) {
                        var x0 = ptBizer.Point0.X * uu * uu * uu;
                        var x1 = 3 * ptBizer.Point1.X * uu * uu * (1 - uu);
                        var x2 = 3 * ptBizer.Point2.X * uu * (1 - uu) * (1 - uu);
                        var x3 = ptBizer.Point3.X * (1 - uu) * (1 - uu) * (1 - uu);

                        var curveX = x0 + x1 + x2 + x3;
                        if (Math.abs(curveX - x) < minDis) {
                            var y0 = ptBizer.Point0.Y * uu * uu * uu;
                            var y1 = 3 * ptBizer.Point1.Y * uu * uu * (1 - uu);
                            var y2 = 3 * ptBizer.Point2.Y * uu * (1 - uu) * (1 - uu);
                            var y3 = ptBizer.Point3.Y * (1 - uu) * (1 - uu) * (1 - uu);
                            minDis = Math.abs(curveX - x);
                            sectY = y0 + y1 + y2 + y3;
                            sectX = curveX;
                        }
                    }
                    return {
                        x: sectX, y: sectY
                    };
                }
                catch (ex) {
                    alert(ex.message);
                }
            }

        }
    };

    var intersection = function (isShow) {
        //alert(m_svg.getPathByName("verticalLine"));

        if (isShow) {
            $(m_svg.getPathByName("verticalLine")).show();
        } else {
            $(m_svg.getPathByName("verticalLine")).hide();
            //$("#verticalLine").hide();
        }
    };

    //通过流量获取扬程
    var getHbyQ4WrkWaterCurve = function (q) {
        var qPixel = getPixelValue(q, m_coordinatePara.CoordMinQ, m_coordinatePara.CoordMaxQ, m_chartSize.SpaceLeft, m_chartSize.DiagramRightX);
        var r = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QH, qPixel);
        if (r == null)
            return 0;
        return getActualValue(m_coordinatePara.CoordMinH, m_coordinatePara.CoordMaxH, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, r.y);
    };

    //通过流量获取效率
    var getEbyQ4WrkWaterCurve = function (q) {
        var qPixel = getPixelValue(q, m_coordinatePara.CoordMinQ, m_coordinatePara.CoordMaxQ, m_chartSize.SpaceLeft, m_chartSize.DiagramRightX);
        var r = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QE, qPixel);
        if (r == null)
            return 0;
        return getActualValue(m_coordinatePara.CoordMinE, m_coordinatePara.CoordMaxE, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, r.y);
    };

    //通过流量获取功率
    var getPbyQ4WrkWaterCurve = function (q) {
        var qPixel = getPixelValue(q, m_coordinatePara.CoordMinQ, m_coordinatePara.CoordMaxQ, m_chartSize.SpaceLeft, m_chartSize.DiagramRightX);
        var r = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QP, qPixel);
        if (r == null)
            return 0;
        return getActualValue(m_coordinatePara.CoordMinP, m_coordinatePara.CoordMaxP, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, r.y);
    };

    //
    var getSvgObjByName = function (objName) {
        return m_svg.getPathByName(objName);
    };

    //查询线
    var m_infoDv4VerticalLine;
    var m_verticalLine;
    var m_dispVerticalLine = false;
    var dispVerticalLine = function (disp) {
        m_dispVerticalLine = disp;
        if (disp) {
            m_infoDv4VerticalLine.show();
            m_verticalLine.show();
        }
        else {
            m_infoDv4VerticalLine.hide();
            m_verticalLine.hide();
        }
    };
    var createVerticalLine = function () {

        if ($("#infoDv4VerticalLine").is("div")) {
            $("#infoDv4VerticalLine").remove();
        }

        //先创建用于放置查询信息的Div
        var htmlDiv = "<lable style='font-size:6px'>流量</label>";
        $("#" + m_divChartName).append($("<div id='infoDv4VerticalLine'></div>").css({
            "position": "relative",//relative  absolute
            "color": "gray",
            "font-size": "8px",
            //"font-family": "Times New Roman",
            //"font-weight": "bold",
            "width": "100px",
            "left": (m_chartSize.DiagramRightX - 100).toString() + "px",
            "top": (12 - m_chartSize.TotalHeight).toString() + "px",// + m_divChartName + "px"
        }).html(htmlDiv).hide());

        m_infoDv4VerticalLine = $("#infoDv4VerticalLine");


        var attr4verticalLine = {
            "stroke": "#A52A2A",
            "stroke-width": "2",
            "fill": "none",
            "zIndex": 100,
            "cursor": 'pointer',
            "stroke-opacity": '1',
            "shape-rendering": "optimizeSpeed",
        };

        var xStartValuePixel = (m_chartSize.SpaceLeft + m_chartSize.DiagramRightX) / 2;  // 开始位置


        //创建竖直线
        var pathValue = new Array();
        var vertialLinePathName = "verticalLine";
        pathValue.push("M ", xStartValuePixel, " ", m_chartSize.SpaceTop, " L ", xStartValuePixel, " ", m_chartSize.DiagramBottomY);
        m_svg.createPath(vertialLinePathName, pathValue.join(''), {
            id: vertialLinePathName
        }, attr4verticalLine, null);

        dispQueryLineInfo(xStartValuePixel);

        var isMoveVerticalLine = false;
        //m_svg.getPathByName("verticalLine")
        m_verticalLine = $(getSvgObjByName(vertialLinePathName));
        m_verticalLine.mousedown(function (e) {
            isMoveVerticalLine = true;
            //WebApp.stopDefault(e);
            e.preventDefault();
            // $("#infoDv4VerticalLine").show();
            //$("#infoDv4VerticalLine").show().css({
            //    "left": e.clientX + 5,
            //    "top": e.clientY
            //});
        });

        $(document).mousemove(function (e) {
            var svg = m_svg.getNode();

            if (isMoveVerticalLine) {
                var e = window.event || e;
                if (e.clientX - $(svg).offset().left > m_chartSize.SpaceLeft &&
                    m_chartSize.DiagramRightX + $(svg).offset().left - e.clientX > 0 &&
                    e.clientY - $(svg).offset().top > m_chartSize.SpaceTop &&
                    m_chartSize.DiagramBottomY + $(svg).offset().top - e.clientY > 0) {
                    //x的像素
                    xPixel = parseFloat(e.clientX - $(svg).offset().left);

                    dispQueryLineInfo(xPixel);

                    var pathValue = new Array();
                    pathValue.push("M ", e.clientX - $(svg).offset().left,
                        " ", m_chartSize.SpaceTop, " L ", e.clientX - $(svg).offset().left, " ", m_chartSize.DiagramBottomY);
                    m_verticalLine.attr("d", pathValue.join(''));//修改位置
                }
            }
        }).mouseup(function (e) {
            if (isMoveVerticalLine) {
                isMoveVerticalLine = false;
                //m_verticalLine.hide();
            }
        });
    };

    var dispQueryLineInfo = function (xPixel) {//x的像素         

        var flow = "流量";
        var head = "扬程";
        var cavitation = "汽蚀";
        var efficiency = "效率";
        var power = "功率";
        if (m_localizationType == 2) {
            flow = "Q";
            head = "H";
            cavitation = "NPSH";
            efficiency = "Eta";
            power = "Power";
        }
        if (m_unitQ == 0) {//LS
            flow = flow + " : " + parseFloat(getActualValue(m_coordinatePara.CoordMinQ / 3.6, m_coordinatePara.CoordMaxQ / 3.6, m_chartSize.SpaceLeft, m_chartSize.DiagramRightX, xPixel)).toFixed(1);
            flow = flow + "L/s";
        }
        else{
	        flow = flow + " : " + parseFloat(getActualValue(m_coordinatePara.CoordMinQ, m_coordinatePara.CoordMaxQ, m_chartSize.SpaceLeft, m_chartSize.DiagramRightX, xPixel)).toFixed(1);
	        flow = flow + "m³/h";
       }
        var hPt = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QH, xPixel);
        if (hPt == null)
            return;
        var h = getActualValue(m_coordinatePara.CoordMinH, m_coordinatePara.CoordMaxH, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, hPt.y);
        if (m_isOutletPressReplaceH) {
            head = "压力";
            if (m_localizationType == 2) {
                head = "Press";
            }
            head = head + " : " + (h / 100).toFixed(3);
            head = head + "MPa";
        }
        else {
            head = head + " : " + h.toFixed(1);
            head = head + "m";
        }

        var etaPt = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QE, xPixel);
        var eta = getActualValue(m_coordinatePara.CoordMinE, m_coordinatePara.CoordMaxE, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, etaPt.y);
        efficiency = efficiency + " : " + eta.toFixed(1);
        efficiency = efficiency + "%";

        var powerPt = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.QP, xPixel);
        var p = getActualValue(m_coordinatePara.CoordMinP, m_coordinatePara.CoordMaxP, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, powerPt.y);
        power = power + " : " + p.toFixed(1);
        power = power + "kW";

        if (m_wrkCurveGrp4Pixel.NPSH != null) {
            var npshPt = getSectPoint4Pixel(m_wrkCurveGrp4Pixel.NPSH, xPixel);
            if (npshPt == null) {
                cavitation = "";//可能没有交点
            }
            else {
                var npsh = getActualValue(m_coordinatePara.CoordMinNPSH, m_coordinatePara.CoordMaxNPSH, m_chartSize.DiagramBottomY, m_chartSize.SpaceTop, npshPt.y);
                cavitation = cavitation + " : " + npsh.toFixed(1);
                cavitation = cavitation + "m";
            }

        }
        else {
            cavitation = "";
        }

        m_infoDv4VerticalLine.show().html(flow + "</br>" + head + "</br>"
+ efficiency + "</br>" + power + "</br>" + cavitation);
    };


    var svgClick = function (e, svg) {

    };

    var svgMove = function (e, svg) {
        //alert("svgMove");
    };

    //初始化面板
    var initialMainPanel = function (divName) {
        if (divName == null) {
            return;
        }
        if (m_chartSize == null) {
            m_chartSize = {};
            m_chartSize.TotalWidth = document.getElementById(divName).clientWidth;
            m_chartSize.TotalHeight = document.getElementById(divName).clientHeight;
        }

        var space_left = 52;
        var space_right = 50;
        var space_top = 12;
        var space_bottom = 45;
        if (m_coordinatePara.CoordSpaceP > 99) {
            space_left = 60;
        }
        if (m_coordinatePara.CoordSpaceP <= 0.1) {
            space_left = 60;
        }
 

        m_chartSize.DigramWidth = m_chartSize.TotalWidth - space_left - space_right;
        m_chartSize.DiagramHeight = m_chartSize.TotalHeight - space_top - space_bottom;

        m_chartSize.SpaceLeft = space_left;
        m_chartSize.SpaceTop = space_top;
        m_chartSize.SpaceRight = space_right;
        m_chartSize.SpaceBottom = space_bottom;

        m_chartSize.DiagramRightX = m_chartSize.TotalWidth - space_right;
        m_chartSize.DiagramBottomY = m_chartSize.TotalHeight - space_bottom;

        m_coordinatePara.SpaceSpixelX = m_chartSize.DigramWidth / m_coordinatePara.GridNumberX;
        m_coordinatePara.SpaceSpixelY = m_chartSize.DiagramHeight / m_coordinatePara.GridNumberY;

        m_coordinatePara.ValidPixelMinH = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.StartLineNoH;
        m_coordinatePara.ValidPixelMaxH = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.EndLineNoH;

        m_coordinatePara.ValidPixelMinE = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.StartLineNoE;
        m_coordinatePara.ValidPixelMaxE = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.EndLineNoE;

        m_coordinatePara.ValidPixelMinP = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.StartLineNoP;
        m_coordinatePara.ValidPixelMaxP = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.EndLineNoP;

        m_coordinatePara.ValidPixelMinNPSH = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.StartLineNoNPSH;
        m_coordinatePara.ValidPixelMaxNPSH = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * m_coordinatePara.EndLineNoNPSH;

        //把间隙弄小点
        var areaAttr = {
            x: space_left,
            y: space_top,
            width: m_chartSize.DigramWidth,
            height: m_chartSize.DiagramHeight
        };

        var areaStyle = {
            "stroke-width": "1px",
            "stroke": "#cccccc",
            "fill": "#ffffff",
            "fill-opacity": "0.5",
            "zIndex:": 5
        };

        //
        m_svg = new window.svgObject().init(divName, m_chartSize.TotalWidth, m_chartSize.TotalHeight, svgClick, svgMove);
        //
        m_svg.createArea(areaAttr, areaStyle);
    };

    //初始化工作曲线
    var intitalWrkCurveInfo = function () {

        m_wrkCurveGrp4Pixel = {};

        var pixelPoints = new Array();
        if (m_chartObject.SimJieZhiCurveQH != null) {
            for (var v = 0; v < m_chartObject.SimJieZhiCurveQH.length; v++) {
                var pt = m_chartObject.SimJieZhiCurveQH[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        else {
            for (var v = 0; v < m_chartObject.MaxWaterCurveQH.length; v++) {
                var pt = m_chartObject.MaxWaterCurveQH[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        m_wrkCurveGrp4Pixel.QH = transBezierCurveModel(pixelPoints);


        pixelPoints = new Array();
        if (m_chartObject.SimJieZhiCurveQE != null) {
            for (var v = 0; v < m_chartObject.SimJieZhiCurveQE.length; v++) {
                var pt = m_chartObject.SimJieZhiCurveQE[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinE) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceE * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        else {
            for (var v = 0; v < m_chartObject.MaxWaterCurveQE.length; v++) {
                var pt = m_chartObject.MaxWaterCurveQE[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinE) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceE * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        m_wrkCurveGrp4Pixel.QE = transBezierCurveModel(pixelPoints);


        pixelPoints = new Array();
        if (m_chartObject.SimJieZhiCurveQP != null) {
            for (var v = 0; v < m_chartObject.SimJieZhiCurveQP.length; v++) {
                var pt = m_chartObject.SimJieZhiCurveQP[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinP) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceP * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        else {
            for (var v = 0; v < m_chartObject.MaxWaterCurveQP.length; v++) {
                var pt = m_chartObject.MaxWaterCurveQP[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinP) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceP * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
        }
        m_wrkCurveGrp4Pixel.QP = transBezierCurveModel(pixelPoints);

        if (m_chartObject.MaxWaterCurveNPSH != null && m_chartObject.MaxWaterCurveNPSH.length > 3) {
            pixelPoints = new Array();
            for (var v = 0; v < m_chartObject.MaxWaterCurveNPSH.length; v++) {
                var pt = m_chartObject.MaxWaterCurveNPSH[v];
                var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DiagramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
                var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinNPSH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceNPSH * m_coordinatePara.GridNumberY);
                pixelPoints.push({ "X": x, "Y": y });
            }
            m_wrkCurveGrp4Pixel.NPSH = transBezierCurveModel(pixelPoints);
        }

    };


    //产生网格线竖直方向
    var createGridLineX = function () {
        if (m_coordinatePara == null) {
            return;
        }

        var attr = {
            "stroke": "#cccccc",
            "stroke-width": "1",
            "fill": "none",
            "zIndex": 10
        };
        if (m_displayStyle != null && m_displayStyle.GridLine != null) {
            attr = m_displayStyle.GridLine;
        }

        for (var i = 0; i <= m_coordinatePara.GridNumberX; i++) {
            var distance = m_coordinatePara.SpaceSpixelX * i;
            var valueTemp = new Array();
            valueTemp.push("M ", m_chartSize.SpaceLeft + distance, " ", m_chartSize.SpaceTop, " L ", m_chartSize.SpaceLeft + distance, " ", m_chartSize.DiagramBottomY);
            m_svg.createPath("GridLienX" + i, valueTemp.join(''), attr, null);
        }
    };

    //产生网格线水平方向
    var createGridLineY = function () {
        if (m_coordinatePara == null) {
            return;
        }

        var attr = {
            "stroke": "#cccccc",
            "stroke-width": "1",
            "fill": "none",
            "zIndex": 10
        };
        if (m_displayStyle != null && m_displayStyle.GridLine != null) {
            attr = m_displayStyle.GridLine;
        }

        for (var i = 0; i <= m_coordinatePara.GridNumberY; i++) {
            var distance = m_coordinatePara.SpaceSpixelY * i;
            var valueTemp = new Array();
            valueTemp.push("M ", m_chartSize.SpaceLeft, " ", m_chartSize.SpaceTop + distance, " L ", m_chartSize.DiagramRightX, " ", m_chartSize.SpaceTop + distance);
            m_svg.createPath("GridLienY" + i, valueTemp.join(''), attr, null);
        }
    };

    //产生装置曲线
    var CreateEquipmentCurve = function () {

        $("#EquipmentCurve").remove();
        if (m_chartObject.EquipmentSectPt == null)
            return;
        var pointNumber = 20;
        var EquipmentCurve = [];
        var space = m_chartObject.EquipmentSectPt.X / (pointNumber - 1);
        var k = (m_chartObject.EquipmentSectPt.Y - m_equipZeroH) / (m_chartObject.EquipmentSectPt.X * m_chartObject.EquipmentSectPt.X);
        for (var i = 0; i < pointNumber; i++) {
            var pt = {};
            pt.X = space * i;
            pt.Y = m_equipZeroH + k * pt.X * pt.X;
            EquipmentCurve.push(pt);
        }
        createCurveQH("EquipmentCurve", EquipmentCurve, 1, m_displayStyle.ColorEquipment, m_dispEquipmentCurve);
    };

    //绘制x坐标(含标题)
    var createXAxis = function () {
        if (m_coordinatePara == null) {
            return;
        }

        //刻度线
        var attrAxisTickX = {
            "stroke": "#cccccc",
            "stroke-width": "1",
            "fill": "none",
            "zIndex": 10
        };

        //刻度长度
        var minTickLength = 4;
        var tickLength = 6;

        //刻度文字
        var styleAxisLabelX = "font-size:10px;fill:red;fill-opacity:1;fill:black;";//font-weight:bold

        //标题文字
        var styleAxisTitleX = "font-size:12px;fill:red;fill-opacity:1;fill:black;font-weight:bold;";//

        //
        var isInterval = false;
        if (m_coordinatePara.GridNumberX > 6)
            isInterval = true;
        for (var i = 0; i <= m_coordinatePara.GridNumberX; i++) {
            var posiX_grid = m_chartSize.SpaceLeft + m_coordinatePara.SpaceSpixelX * i;

            //刻度线
            var valueMain = new Array();
            valueMain.push("M ", posiX_grid, " ", m_chartSize.DiagramBottomY, " L ", posiX_grid, " ", m_chartSize.DiagramBottomY + tickLength);
            m_svg.createPath("TickLineX" + i, valueMain.join(''), attrAxisTickX, null);

            //文字 
            var content = 0;
            if (m_unitQ == 0) {//LS
                content = valueFormat(m_coordinatePara.CoordMinQ / 3.6 + i * m_coordinatePara.CoordSpaceQ / 3.6);
            }
            else {
                content = valueFormat(m_coordinatePara.CoordMinQ + i * m_coordinatePara.CoordSpaceQ);
            }
            if (isInterval) {
                if (i % 2 == 0) {
                    var attrAxisLabelX = {
                        "opacity": 1,
                        "x": posiX_grid,
                        "y": m_chartSize.DiagramBottomY + tickLength + 15,
                        "text-anchor": "middle"
                    };

                    m_svg.createText(attrAxisLabelX, styleAxisLabelX, content);
                }
            }
            else {
                var attrAxisLabelX = {
                    "opacity": 1,
                    "x": posiX_grid,
                    "y": m_chartSize.DiagramBottomY + tickLength + 15,
                    "text-anchor": "middle"
                };

                m_svg.createText(attrAxisLabelX, styleAxisLabelX, content);
            }

            //子刻度线
            if (m_isDispMiniTick && i != m_coordinatePara.GridNumberX) {
                for (var j = 1 ; j <= m_MiniTickNumber; j++) {
                    var pois_minTick = posiX_grid + m_coordinatePara.SpaceSpixelX * j / (m_MiniTickNumber + 1);
                    var valueMini = new Array();
                    valueMini.push("M ", pois_minTick, " ", m_chartSize.DiagramBottomY, " L ", pois_minTick, " ", m_chartSize.DiagramBottomY + minTickLength);
                    m_svg.createPath("TickMinLineX" + i, valueMini.join(''), attrAxisTickX, null);
                }
            }
        }

        if (m_localizationType == 0) {//中文
            var attrAxisTitleX = {
                "opacity": 1,
                "x": (m_chartSize.SpaceLeft + m_chartSize.DiagramRightX) / 2 ,
                "y": m_chartSize.DiagramBottomY + 40,
                "text-anchor": "middle"
            };
            if (m_unitQ == 0) {//LS
                m_svg.createText(attrAxisTitleX, styleAxisTitleX, "流量 (L/s)");
            }
            else {
                m_svg.createText(attrAxisTitleX, styleAxisTitleX, "流量 (m³/h)");
            }
        }
        else {
            var attrAxisTitleX = {
                "opacity": 1,
                "x": (m_chartSize.SpaceLeft + m_chartSize.DiagramRightX) / 2 ,
                "y": m_chartSize.DiagramBottomY + 40,
                "text-anchor": "middle"
            };
            if (m_unitQ == 0) {//LS
                m_svg.createText(attrAxisTitleX, styleAxisTitleX, "Flow (L/s)");
            }
            else {
                m_svg.createText(attrAxisTitleX, styleAxisTitleX, "Flow (m³/h)");
            }
        }
    };

    //绘制Y坐标(含标题)
    var createYAxis = function () {
        if (m_coordinatePara == null) {
            return;
        }

        //刻度长度
        var minTickLength = 3;
        var tickLength = 6;

        //扬程
        if (m_coordinatePara.EndLineNoH > m_coordinatePara.StartLineNoH) {
            //刻度线
            var attrAxisTickH = {
                "stroke": "#cccccc",
                "stroke-width": "1",
                "fill": "none",
                "zIndex": 10
            };

            //刻度文字
            var styleAxisLabelH = "font-size:10px; fill-opacity:1; fill:" + m_displayStyle.ColorH + ";";
            //标签 
            var styleAxisTitleH = "font-size:12px; ;fill-opacity:1; font-weight:bold; fill:" + m_displayStyle.ColorH + ";";

            //标签         
            var attrAxisTitleH = {
                "opacity": 1,
                "x": m_chartSize.SpaceLeft - 40,
                "y": m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * (m_coordinatePara.StartLineNoH + m_coordinatePara.EndLineNoH) / 2 - 10,
                "text-anchor": "middle"
            };

            if (m_localizationType == 0) {//中文   

                if (m_isOutletPressReplaceH) {//优先度高
                    attrAxisTitleH.y = attrAxisTitleH.y - 5;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "压");
                    attrAxisTitleH.y = attrAxisTitleH.y + 15;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "力");

                    attrAxisTitleH.x = attrAxisTitleH.x + 3;
                    attrAxisTitleH.y = attrAxisTitleH.y + 18;
                    var transform = "rotate(-90 " + attrAxisTitleH.x + "," + attrAxisTitleH.y + ")";
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, " MPa", 10, null, transform);
                }
                else if (m_coordinatePara.UnitH == 0) {

                    attrAxisTitleH.y = attrAxisTitleH.y - 5;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "扬");
                    attrAxisTitleH.y = attrAxisTitleH.y + 15;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "程");

                    attrAxisTitleH.x = attrAxisTitleH.x + 3;
                    attrAxisTitleH.y = attrAxisTitleH.y + 21;
                    var transform = "rotate(-90 " + attrAxisTitleH.x + "," + attrAxisTitleH.y + ")";
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, " (m)", 10, null, transform);
                }
                else {
                    attrAxisTitleH.y = attrAxisTitleH.y - 5;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "扬");
                    attrAxisTitleH.y = attrAxisTitleH.y + 15;
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "程");
                }
            }
            else {
 
                if (m_isOutletPressReplaceH) {//优先度高
                    attrAxisTitleH.x = attrAxisTitleH.x + 3;
                    attrAxisTitleH.y = attrAxisTitleH.y + 21;
                    var transform = "rotate(-90 " + attrAxisTitleH.x + "," + attrAxisTitleH.y + ")";
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "Press (MPa)", 10, null, transform);
                }
                else if (m_coordinatePara.UnitH == 0) {
                    attrAxisTitleH.x = attrAxisTitleH.x + 3;
                    attrAxisTitleH.y = attrAxisTitleH.y + 21;
                    var transform = "rotate(-90 " + attrAxisTitleH.x + "," + attrAxisTitleH.y + ")";
                    m_svg.createText(attrAxisTitleH, styleAxisTitleH, "Press (m)", 10, null, transform);
                }
            }


            //
            for (var i = m_coordinatePara.StartLineNoH; i <= m_coordinatePara.EndLineNoH; i++) {
                var content = valueFormat(m_coordinatePara.CoordMinH + i * m_coordinatePara.CoordSpaceH);

                var posiY_grid = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * i;
                //主刻度
                var valueMain = new Array();
                valueMain.push("M ", m_chartSize.SpaceLeft, " ", posiY_grid, " L ", m_chartSize.SpaceLeft - tickLength, " ", posiY_grid);
                m_svg.createPath("TickLineH" + i, valueMain.join(''), attrAxisTickH, null);

                //文字
                var attrAxisLabelH = {
                    "opacity": 1,
                    "x": m_chartSize.SpaceLeft - 8,
                    "y": posiY_grid + 4,
                    "text-anchor": "end"
                };
                if (m_isOutletPressReplaceH) {//仅仅改变显示值
                    content = content / 100;
                }
                m_svg.createText(attrAxisLabelH, styleAxisLabelH, content);

                //子刻度线
                if (m_isDispMiniTick && i != m_coordinatePara.EndLineNoH) {
                    for (var j = 1 ; j <= m_MiniTickNumber; j++) {
                        var pois_minTick = posiY_grid - m_coordinatePara.SpaceSpixelY * j / (m_MiniTickNumber + 1);
                        var valueMini = new Array();
                        valueMini.push("M ", m_chartSize.SpaceLeft, " ", pois_minTick, " L ", m_chartSize.SpaceLeft - minTickLength, " ", pois_minTick);
                        m_svg.createPath("TickMinLineH" + i, valueMini.join(''), attrAxisTickH, null);
                    }
                }
            }
        }



        //功率
        if (m_coordinatePara.EndLineNoP > m_coordinatePara.StartLineNoP) {
            //刻度线
            var attrAxisTickP = {
                "stroke": "#cccccc",
                "stroke-width": "1",
                "fill": "none",
                "zIndex": 10
            };

            //刻度文字
            var styleAxisLabelP = "font-size:10px; fill-opacity:1; fill:" + m_displayStyle.ColorP + ";";
            //标签 
            var styleAxisTitleP = "font-size:12px; ;fill-opacity:1; font-weight:bold; fill:" + m_displayStyle.ColorP + ";";

            //标签
            if (m_localizationType == 0) {//中文
                var attrAxisTitleP = {
                    "opacity": 1,
                    "x": m_chartSize.SpaceLeft - 40,
                    "y": m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * (m_coordinatePara.StartLineNoP + m_coordinatePara.EndLineNoP) / 2 - 10,
                    "text-anchor": "middle"
                };
                if (m_coordinatePara.CoordSpaceP <= 0.1) {
                    attrAxisTitleP.x = attrAxisTitleP.x - 5;
                }
                attrAxisTitleP.y = attrAxisTitleP.y - 5;
                m_svg.createText(attrAxisTitleP, styleAxisTitleP, "功");
                attrAxisTitleP.y = attrAxisTitleP.y + 15;
                m_svg.createText(attrAxisTitleP, styleAxisTitleP, "率");
                attrAxisTitleP.x = attrAxisTitleP.x + 4;
                attrAxisTitleP.y = attrAxisTitleP.y + 25;
                var transform = "rotate(-90 " + attrAxisTitleP.x + "," + attrAxisTitleP.y + ")";
                m_svg.createText(attrAxisTitleP, styleAxisTitleP, "(kW)", 10, null, transform);

            }
            else {
                var attrAxisTitleP = {
                    "opacity": 1,
                    "x": m_chartSize.SpaceLeft - 42,
                    "y": m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * (m_coordinatePara.StartLineNoP + m_coordinatePara.EndLineNoP) / 2 - 10,
                    "text-anchor": "middle"
                };
                if (m_coordinatePara.CoordSpaceP <= 0.1) {
                    attrAxisTitleP.x = attrAxisTitleP.x - 5;
                }
                attrAxisTitleP.x = attrAxisTitleP.x + 4;
                attrAxisTitleP.y = attrAxisTitleP.y + 25;
                var transform = "rotate(-90 " + attrAxisTitleP.x + "," + attrAxisTitleP.y + ")";
                m_svg.createText(attrAxisTitleP, styleAxisTitleP, "Power (kW)", 10, null, transform);
            }

            //
            for (var i = m_coordinatePara.StartLineNoP; i <= m_coordinatePara.EndLineNoP; i++) {
                var content = valueFormat(m_coordinatePara.CoordMinP + i * m_coordinatePara.CoordSpaceP);

                var posiY_grid = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * i;
                //主刻度
                var valueMain = new Array();
                valueMain.push("M ", m_chartSize.SpaceLeft, " ", posiY_grid, " L ", m_chartSize.SpaceLeft - tickLength, " ", posiY_grid);
                m_svg.createPath("TickLineP" + i, valueMain.join(''), attrAxisTickP, null);

                //文字
                var attrAxisLabelP = {
                    "opacity": 1,
                    "x": m_chartSize.SpaceLeft - 8,
                    "y": posiY_grid + 4,
                    "text-anchor": "end"
                };
 
                m_svg.createText(attrAxisLabelP, styleAxisLabelP, content);

                //子刻度线
                if (m_isDispMiniTick && i != m_coordinatePara.EndLineNoP) {
                    for (var j = 1 ; j <= m_MiniTickNumber; j++) {
                        var pois_minTick = posiY_grid - m_coordinatePara.SpaceSpixelY * j / (m_MiniTickNumber + 1);
                        var valueMini = new Array();
                        valueMini.push("M ", m_chartSize.SpaceLeft, " ", pois_minTick, " L ", m_chartSize.SpaceLeft - minTickLength, " ", pois_minTick);
                        m_svg.createPath("TickMinLineP" + i, valueMini.join(''), attrAxisTickP, null);
                    }
                }

            }
        }



        //效率
        if (m_coordinatePara.EndLineNoE > m_coordinatePara.StartLineNoE && m_isDispCurveQE) {
            //刻度线
            var attrAxisTickE = {
                "stroke": "#cccccc",
                "stroke-width": "1",
                "fill": "none",
                "zIndex": 10
            };

            //刻度文字
            var styleAxisLabelE = "font-size:10px; fill-opacity:1; fill:" + m_displayStyle.ColorE + ";";
            //标签 
            var styleAxisTitleE = "font-size:12px; ;fill-opacity:1; font-weight:bold; fill:" + m_displayStyle.ColorE + ";";
            //
            var attrAxisTitleE = {
                "opacity": 1,
                "x": m_chartSize.DiagramRightX + 39,
                "y": m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * (m_coordinatePara.StartLineNoE + m_coordinatePara.EndLineNoE) / 2 - 10,
                "text-anchor": "middle"
            };

            //标签
            if (m_localizationType == 0) {//中文
                attrAxisTitleE.y = attrAxisTitleE.y - 5;
                m_svg.createText(attrAxisTitleE, styleAxisTitleE, "效");
                attrAxisTitleE.y = attrAxisTitleE.y + 15;
                m_svg.createText(attrAxisTitleE, styleAxisTitleE, "率");
                attrAxisTitleE.x = attrAxisTitleE.x + 6;
                attrAxisTitleE.y = attrAxisTitleE.y + 20;
                var transform = "rotate(-90 " + attrAxisTitleE.x + "," + attrAxisTitleE.y + ")";
                m_svg.createText(attrAxisTitleE, styleAxisTitleE, "(%)", 10, null, transform);
            }
            else {
                attrAxisTitleE.x = attrAxisTitleE.x + 6;
                attrAxisTitleE.y = attrAxisTitleE.y + 20;
                var transform = "rotate(-90 " + attrAxisTitleE.x + "," + attrAxisTitleE.y + ")";
                m_svg.createText(attrAxisTitleE, styleAxisTitleE, "Eta (%)", 10, null, transform);
            }

            //
            for (var i = m_coordinatePara.StartLineNoE; i <= m_coordinatePara.EndLineNoE; i++) {
                var content = m_coordinatePara.CoordMinE + i * m_coordinatePara.CoordSpaceE;
                var posiY_grid = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * i;
                //主刻度
                var valueMain = new Array();
                valueMain.push("M ", m_chartSize.DiagramRightX, " ", posiY_grid, " L ", m_chartSize.DiagramRightX + tickLength, " ", posiY_grid);
                m_svg.createPath("TickLineP" + i, valueMain.join(''), attrAxisTickE, null);

                //文字
                var attrAxisLabelE = {
                    "opacity": 1,
                    "x": m_chartSize.DiagramRightX + 10,
                    "y": posiY_grid + 4
                };
                m_svg.createText(attrAxisLabelE, styleAxisLabelE, content);

                //子刻度线
                if (m_isDispMiniTick && i != m_coordinatePara.EndLineNoE) {
                    for (var j = 1 ; j <= m_MiniTickNumber; j++) {
                        var pois_minTick = posiY_grid - m_coordinatePara.SpaceSpixelY * j / (m_MiniTickNumber + 1);
                        var valueMini = new Array();
                        valueMini.push("M ", m_chartSize.DiagramRightX, " ", pois_minTick, " L ", m_chartSize.DiagramRightX + minTickLength, " ", pois_minTick);
                        m_svg.createPath("TickMinLineE" + i, valueMini.join(''), attrAxisTickE, null);
                    }
                }

            }
        }


        //汽蚀
        if (m_isDispNpsh && m_coordinatePara.EndLineNoNPSH > m_coordinatePara.StartLineNoNPSH) {
            //刻度线
            var attrAxisTickNPSH = {
                "stroke": "#cccccc",
                "stroke-width": "1",
                "fill": "none",
                "zIndex": 10
            };

            //刻度文字
            var styleAxisLabelNPSH = "font-size:10px; fill-opacity:1; fill:" + m_displayStyle.ColorNPSH + ";";
            //标签 
            var styleAxisTitleNPSH = "font-size:12px; ;fill-opacity:1; font-weight:bold; fill:" + m_displayStyle.ColorNPSH + ";";

            //标签
            var attrAxisTitleNPSH = {
                "opacity": 1,
                "x": m_chartSize.DiagramRightX + 39,
                "y": m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * (m_coordinatePara.StartLineNoNPSH + m_coordinatePara.EndLineNoNPSH) / 2 - 10,
                "text-anchor": "middle"
            };
            if (m_localizationType == 0) {//中文
                attrAxisTitleNPSH.y = attrAxisTitleNPSH.y - 5;
                m_svg.createText(attrAxisTitleNPSH, styleAxisTitleNPSH, "汽");
                attrAxisTitleNPSH.y = attrAxisTitleNPSH.y + 15;
                m_svg.createText(attrAxisTitleNPSH, styleAxisTitleNPSH, "蚀");
                attrAxisTitleNPSH.x = attrAxisTitleNPSH.x + 5;
                attrAxisTitleNPSH.y = attrAxisTitleNPSH.y + 20;
                var transform = "rotate(-90 " + attrAxisTitleNPSH.x + "," + attrAxisTitleNPSH.y + ")";
                m_svg.createText(attrAxisTitleNPSH, styleAxisTitleNPSH, "(m)", 10, null, transform);
            }
            else {
                attrAxisTitleNPSH.x = attrAxisTitleNPSH.x + 5;
                attrAxisTitleNPSH.y = attrAxisTitleNPSH.y + 10;
                var transform = "rotate(-90 " + attrAxisTitleNPSH.x + "," + attrAxisTitleNPSH.y + ")";
                m_svg.createText(attrAxisTitleNPSH, styleAxisTitleNPSH, "NPSH (m)", 10, null, transform);
            }

            //
            for (var i = m_coordinatePara.StartLineNoNPSH; i <= m_coordinatePara.EndLineNoNPSH; i++) {
                var content = valueFormat(m_coordinatePara.CoordMinNPSH + i * m_coordinatePara.CoordSpaceNPSH);

                var posiY_grid = m_chartSize.DiagramBottomY - m_coordinatePara.SpaceSpixelY * i;
                //主刻度
                var valueMain = new Array();
                valueMain.push("M ", m_chartSize.DiagramRightX, " ", posiY_grid, " L ", m_chartSize.DiagramRightX + tickLength, " ", posiY_grid);
                m_svg.createPath("TickLineNPSH" + i, valueMain.join(''), attrAxisTickNPSH, null);

                //文字
                var attrAxisLabelNPSH = {
                    "opacity": 1,
                    "x": m_chartSize.DiagramRightX + 10,
                    "y": posiY_grid + 4
                };
                m_svg.createText(attrAxisLabelNPSH, styleAxisLabelNPSH, content);

                //子刻度线
                if (m_isDispMiniTick && i != m_coordinatePara.EndLineNoNPSH) {

                    for (var j = 1 ; j <= m_MiniTickNumber; j++) {
                        var pois_minTick = posiY_grid - m_coordinatePara.SpaceSpixelY * j / (m_MiniTickNumber + 1);
                        var valueMini = new Array();
                        valueMini.push("M ", m_chartSize.DiagramRightX, " ", pois_minTick, " L ", m_chartSize.DiagramRightX + minTickLength, " ", pois_minTick);
                        m_svg.createPath("TickMinLineE" + i, valueMini.join(''), attrAxisTickNPSH, null);
                    }
                }

            }
        }
    };

    //产生型谱
    var craeteSpectrumShape = function (spectrumShape) {
        if (spectrumShape == null)
            return;

        var pathValue = new Array();

        var coordinates_Left = new Array();
        var points = spectrumShape["LeftParabolaPoints"];
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
            coordinates_Left.push({ "X": x, "Y": y });
        }
        var bezierCurveValue = transBezierCurveModel(coordinates_Left);
        for (var h = 0; h < bezierCurveValue.length; h++) {
            if (h == 0) {
                pathValue.push("M ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
                pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);

            }
            else {
                pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
                pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            }
        }

        var coordinates_Top = new Array();
        points = spectrumShape["BasePoints"];
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
            coordinates_Top.push({ "X": x, "Y": y });
        }
        bezierCurveValue = transBezierCurveModel(coordinates_Top);
        for (var h = 0; h < bezierCurveValue.length; h++) {

            pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
            pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
        }


        var coordinates_bottom = new Array();
        points = spectrumShape["SimularPoints"];
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
            coordinates_bottom.push({ "X": x, "Y": y });
        }
        bezierCurveValue = transBezierCurveModel(coordinates_bottom);
        for (var h = 0; h < bezierCurveValue.length; h++) {
            pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
            pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
        }


        var coordinates_right = new Array();
        points = spectrumShape["RightParabolaPoints"];
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
            coordinates_right.push({ "X": x, "Y": y });
        }
        var bezierCurveValue = transBezierCurveModel(coordinates_right);
        for (var h = 0; h < bezierCurveValue.length; h++) {

            pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
            pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            if (h == bezierCurveValue.length - 1) {
                pathValue.push(" L ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
            }
        }


        var style = {
            "stroke-width": "1",
            "stroke": "none",
            "fill": "yellow",
            "stroke-opacity": '0.1',
            "fill-opacity": "0.3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": -1
        };
        m_svg.createPath("SpectrumShape", pathValue.join(''), {
            "id": "SpectrumShape"
        }, style);
    };

    //绘制曲线
    var createCurveQH = function (objName, points, curveWidth, curveColor, isDisp, strokeDasharray) {
        if (points == null) {
            return;
        }
        if (objName == null) {
            return;
        }


        var pixelPoints = new Array();
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
            pixelPoints.push({ "X": x, "Y": y });
        }

        var pathValue = transBezierCurveToPath(pixelPoints);
        //var bezierCurveValue = transBezierCurveModel(pixelPoints);
        //if (bezierCurveValue == null) {
        //    return;
        //}
        //var pathValue = new Array();
        //for (var h = 0; h < bezierCurveValue.length; h++) {
        //    if (h == 0) {
        //        pathValue.push("M ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
        //        pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);

        //    }
        //    else {
        //        pathValue.push(" L ", bezierCurveValue[h].Point0.X, " ", bezierCurveValue[h].Point0.Y);
        //        pathValue.push(" C ", bezierCurveValue[h].Point1.X, " ", bezierCurveValue[h].Point1.Y, " ", bezierCurveValue[h].Point2.X, " ", bezierCurveValue[h].Point2.Y, " ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
        //    }
        //    if (h == bezierCurveValue.length - 1) {
        //        pathValue.push(" L ", bezierCurveValue[h].Point3.X, " ", bezierCurveValue[h].Point3.Y);
        //    }
        //}

        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorH,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (curveWidth != null) {
            style["stroke-width"] = curveWidth;
        }
        if (curveColor != null) {
            style["stroke"] = curveColor;
        }
        if (strokeDasharray != null) {
            style["stroke-dasharray"] = strokeDasharray;//'10, 10';//'10, 10, 5, 5'
        }

        m_svg.createPath(objName, pathValue.join(''), {
            "id": objName
        }, style);
        if (isDisp != null && !isDisp) {
            $("#" + objName).hide();
        }
        return pixelPoints;
    };

    //绘制直线
    var createLineQH = function (objName, point1, point2, curveWidth, curveColor, objTag) {
        if (point1 == null || point2 == null) {
            return;
        }
        if (objName == null) {
            return;
        }


        var x1 = m_chartSize.SpaceLeft + (point1.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
        var y1 = m_chartSize.DiagramBottomY - (point1.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);


        var x2 = m_chartSize.SpaceLeft + (point2.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
        var y2 = m_chartSize.DiagramBottomY - (point2.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);

        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorH,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (curveWidth != null) {
            style["stroke-width"] = curveWidth;
        }
        if (curveColor != null) {
            style["stroke"] = curveColor;
        }
        var temp = "M x1 y1 L x2 y2";
        var pathValue = temp.replace("x1", x1).replace("y1", y1).replace("x2", x2).replace("y2", y2);
        if (objTag == null)
            m_svg.createPath(objName, pathValue, null, style);
        else
            m_svg.createPath(objName, pathValue, { "tag": objTag }, style);
    };
    //绘制点
    var createPointQH = function (objName, point, circleSize, circleColor) {
        if (point == null) {
            return;
        }
        if (objName == null) {
            return;
        }

        var xPixel = m_chartSize.SpaceLeft + (point.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
        var yPixel = m_chartSize.DiagramBottomY - (point.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);

        var attr = {
            "cx": xPixel,
            "cy": yPixel,
            "r": 2
        }
        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorH,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (circleSize != null) {
            attr.r = circleSize;
        }
        if (circleColor != null) {
            style["stroke"] = circleColor;
        }

        m_svg.createCircle(objName, attr, style);
    };
    //绘制文字
    //textAnchor 文字对齐 start | middle | end
    var drawTextByQH = function (objName, text, point, textSize, textColor, offsetPixelX, offsetPixelY, textAnchor) {
        if (!text) {
            return;
        }
        if (!point) {
            return;
        }
        var xPixel = m_chartSize.SpaceLeft + (point.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
        if (offsetPixelX != null) {
            xPixel += offsetPixelX;
        }

        var yPixel = m_chartSize.DiagramBottomY - (point.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);
        if (offsetPixelY != null) {
            yPixel -= offsetPixelY;
        }

        var textStyle = "stroke-width:1px;";//font-weight:bold; fill-opacity:0.9;
        if (textColor != null) {
            textStyle += " fill:" + textColor + ";";
        }
        else {
            textStyle += " fill:#000000;";
        }
        if (textSize != null) {
            textStyle += " font-size:" + textSize + "px;"
        } else {
            textStyle += " font-size:12px;";
        }
        if (textAnchor != null) {
            textStyle += " text-anchor:" + textAnchor + ";";
        }
        return m_svg.createText({
            "opacity": 0.5,
            "y": yPixel,
            "x": xPixel
        }, textStyle, text);
    };

    //
    var createCurveQE = function (objName, points, curveWidth, curveColor, isDisp, strokeDasharray) {
        if (points == null) {
            return;
        }
        if (objName == null) {
            return;
        }

        var pixelPoints = new Array();
        for (var v = 0; v < points.length; v++) {
            if (v == 0 && points[0].X < 10) {//强制归零
                points[0].X = 0;
                points[0].Y = 0;
            }
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinE) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceE * m_coordinatePara.GridNumberY);
            pixelPoints.push({ "X": x, "Y": y });
        }

        var pathValue = transBezierCurveToPath(pixelPoints);

        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorE,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (strokeDasharray != null) {
            style["stroke-dasharray"] = strokeDasharray;//'10, 10';//'10, 10, 5, 5'
        }
        if (curveWidth != null) {
            style["stroke-width"] = curveWidth;
        }
        if (curveColor != null) {
            style["stroke"] = curveColor;
        }
        m_svg.createPath(objName, pathValue.join(''), {
            "id": objName
        }, style);
        if (isDisp != null && !isDisp) {
            $("#" + objName).hide();
        }
        return pixelPoints;
    };

    var createCurveQP = function (objName, points, curveWidth, curveColor, isDisp, strokeDasharray) {
        if (points == null) {
            return;
        }
        if (objName == null) {
            return;
        }

        var pixelPoints = new Array();
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinP) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceP * m_coordinatePara.GridNumberY);
            pixelPoints.push({ "X": x, "Y": y });
        }

        var pathValue = transBezierCurveToPath(pixelPoints);

        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorP,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (curveWidth != null) {
            style["stroke-width"] = curveWidth;
        }
        if (curveColor != null) {
            style["stroke"] = curveColor;
        }
        if (strokeDasharray != null) {
            style["stroke-dasharray"] = strokeDasharray;//'10, 10';//'10, 10, 5, 5'
        }
        m_svg.createPath(objName, pathValue.join(''), {
            "id": objName
        }, style);
        if (isDisp != null && !isDisp) {
            $("#" + objName).hide();
        }
        return pixelPoints;
    };

    var createCurveNPSH = function (objName, points, curveWidth, curveColor) {
        if (points == null || m_coordinatePara.CoordSpaceNPSH < 0.1) {
            return;
        }
        if (objName == null) {
            return;
        }

        var pixelPoints = new Array();
        for (var v = 0; v < points.length; v++) {
            var pt = points[v];
            var x = m_chartSize.SpaceLeft + (pt.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var y = m_chartSize.DiagramBottomY - (pt.Y - m_coordinatePara.CoordMinNPSH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceNPSH * m_coordinatePara.GridNumberY);
            pixelPoints.push({ "X": x, "Y": y });
        }


        var pathValue = transBezierCurveToPath(pixelPoints);

        var style = {
            "stroke-width": "2px",
            "stroke": m_displayStyle.ColorNPSH,
            "fill": "none",
            "fill-opacity": "0.5",
            //"stroke-dasharray":"5 3",
            "shape-rendering": "optimizeSpeed",
            "zIndex:": 7
        };
        if (curveWidth != null) {
            style["stroke-width"] = curveWidth;
        }
        if (curveColor != null) {
            style["stroke"] = curveColor;
        }
        m_svg.createPath(objName, pathValue.join(''), {
            "id": objName
        }, style);
    };

    //绘制LOGO
    var setTextLogo = function (text) {
        if (!text) {
            return;
        }

        var logoStyle = "-webkit-transform: rotate(5deg);-moz-transform: rotate(5deg);transform: rotate(5deg);fill:#000000;fill-opacity:0.6;font-weight:bold;stroke-width:1px";
        var srt = text.toString();
        var w = 30;
        var h = 80;
        var isDrawSecond = true;
        var left = null;
        var lingHeight = 250;
        if (m_systemPlantType == 0) {
            logoStyle += ";font-size:14px"
        } else {
            logoStyle += ";font-size:10px";
            w = 12;
            h = 35;
            isDrawSecond = false;
        }

        left = (m_chartSize.DiagramRightX - m_chartSize.SpaceLeft - srt.length * w) / 2;

        for (var i = 0; i < srt.length; i++) {
            m_svg.createText({
                "opacity": 0.5,
                "y": m_chartSize.SpaceTop + h + i * 10,
                "x": m_chartSize.SpaceLeft + left + i * w
            }, logoStyle, srt[i]);

            if (isDrawSecond) {
                var endHeight = h + srt.length * 10;//: h + srt.length * 10 - 80;
                m_svg.createText({
                    "opacity": 0.5,
                    "y": m_chartSize.DiagramBottomY - endHeight + i * 10,
                    "x": m_chartSize.SpaceLeft + left + i * w
                }, logoStyle, srt[i])
            }
        }

    };

    //绘制设计点
    var drawDesignPoint = function (DesignPointDispType) {
        if (m_chartObject.DesignPoint1 == null)
            return;

        if (DesignPointDispType == 2) {//倒三角

            var xPixel = m_chartSize.SpaceLeft +
                (m_chartObject.DesignPoint1.X - m_coordinatePara.CoordMinQ) * m_chartSize.DigramWidth / (m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX);
            var yPixel = m_chartSize.DiagramBottomY -
                (m_chartObject.DesignPoint1.Y - m_coordinatePara.CoordMinH) * m_chartSize.DiagramHeight / (m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY);

            var xTri = m_chartSize.DigramWidth / 10;
            var yTri = xTri / 2;
            var style = {
                "stroke-width": "2px",
                "stroke": "red",
                "fill": "none",
                "fill-opacity": "0.5",
                //"stroke-dasharray":"5 3",
                "shape-rendering": "optimizeSpeed",
                "zIndex:": 18
            };
            //if (curveWidth != null) {
            //    style["stroke-width"] = curveWidth;
            //}
            //if (curveColor != null) {
            //    style["stroke"] = curveColor;
            //}


            var temp = "M x1 y1 L x2 y2";
            var pathValue = temp.replace("x1", xPixel).replace("y1", yPixel).replace("x2", (xPixel - xTri)).replace("y2", yPixel);
            m_svg.createPath("DesignPointWater1", pathValue, {
                //"class": "DesignPointWater1",
                "tag": "DesignPoint1"
            }, style);
            pathValue = temp.replace("x1", xPixel).replace("y1", yPixel).replace("x2", xPixel).replace("y2", (yPixel + yTri));
            m_svg.createPath("DesignPointWater2", pathValue, {
                //"class": "DesignPointWater2",
                "tag": "DesignPoint1"
            }, style);
            pathValue = temp.replace("x1", xPixel - xTri).replace("y1", yPixel).replace("x2", xPixel).replace("y2", (yPixel + yTri));
            m_svg.createPath("DesignPointWater3", pathValue, {
                //"class": "DesignPointWater3",
                "tag": "DesignPoint1"
            }, style);


            //m_svg.createPath(objName, pathValue.join(''), {
            //    "id": objName
            //}, style);

            pathValue = temp.replace("x1", xPixel - xTri / 3).replace("y1", yPixel).replace("x2", xPixel).replace("y2", (yPixel + yTri / 3));
            m_svg.createPath("DesignPointWater4", pathValue, {
                //"class": "DesignPointWater4",
                "tag": "DesignPoint1"
            }, style);

            pathValue = temp.replace("x1", xPixel - xTri * 2 / 3).replace("y1", yPixel).replace("x2", xPixel).replace("y2", (yPixel + yTri * 2 / 3));
            m_svg.createPath("DesignPointWater5", pathValue, {
                //"class": "DesignPointWater5",
                "tag": "DesignPoint1"
            }, style);

        }
        else {//十字线
            var x = m_chartObject.DesignPoint1.X;
            var y = m_chartObject.DesignPoint1.Y;
            var point1 = { X: x, Y: y * m_designPointTolerance[0] };
            var point2 = { X: x, Y: y * m_designPointTolerance[1] };
            createLineQH("DesignPointWater1", point1, point2, 2, "red", "DesignPoint1");

            point1 = { X: x * m_designPointTolerance[2], Y: y };
            point2 = { X: x * m_designPointTolerance[3], Y: y };
            createLineQH("DesignPointWater2", point1, point2, 2, "red", "DesignPoint1");
        }

    };

    //设置语言 中文zhCN = 0, zhTW = 1,   enUS = 2
    this.setLocalizationType = function (localizationType) {
        m_localizationType = localizationType;
    };

    //设置系统
    this.setSystemPlantType = function (type) {
        m_systemPlantType = type;
    };

    //设置容器
    this.setContainerDiv = function (divChartName, divWidth, divHeight) {
        m_divChartName = divChartName;
        if (divWidth != null && divHeight != null) {
            if (m_chartSize == null) {
                m_chartSize = {};
            }

            m_chartSize.TotalWidth = divWidth;
            m_chartSize.TotalHeight = divHeight;
        }
    };
    //初始化图表(入口)
    this.initialChart = function (ChartFullInfo, displayStyle) {

        if (!m_divChartName)
            return;

        if (ChartFullInfo.Coordinate == null)
            return;
        if (ChartFullInfo.ChartObject == null)
            return;

        m_chartType = ChartFullInfo.ChartType;
        m_pumpInfo = ChartFullInfo.PumpInfo;
        m_chartObject = ChartFullInfo.ChartObject;
        m_coordinatePara = ChartFullInfo.Coordinate;//extend(m_coordinatePara, ChartFullInfo.Coordinate);

        m_coordinatePara.CoordMaxQ = m_coordinatePara.CoordMinQ + m_coordinatePara.CoordSpaceQ * m_coordinatePara.GridNumberX;
        m_coordinatePara.CoordMaxH = m_coordinatePara.CoordMinH + m_coordinatePara.CoordSpaceH * m_coordinatePara.GridNumberY;
        m_coordinatePara.CoordMaxE = m_coordinatePara.CoordMinE + m_coordinatePara.CoordSpaceE * m_coordinatePara.GridNumberY;
        m_coordinatePara.CoordMaxP = m_coordinatePara.CoordMinP + m_coordinatePara.CoordSpaceP * m_coordinatePara.GridNumberY;
        m_coordinatePara.CoordMaxNPSH = m_coordinatePara.CoordMinNPSH + m_coordinatePara.CoordSpaceNPSH * m_coordinatePara.GridNumberY;

        m_isDispNpsh = true;
        if (m_chartObject.MaxWaterCurveNPSH == null)
            m_isDispNpsh = false;
        if (m_pumpInfo.IsDispCurveQE != null) {
            m_isDispCurveQE = m_pumpInfo.IsDispCurveQE;
        }

        //显示
        if (displayStyle != null) {
            m_displayStyle = displayStyle;
        }
        else {
            m_displayStyle = {};
            m_displayStyle.DesignPointDispType = 0;//设计点显示方式(eDesignPointDispType) Cross 0  LeftDownTriangle 2
        }
        m_displayStyle.GridLine = {
            "stroke": "#cccccc",
            "stroke-width": "1",
            "fill": "none",
            "zIndex": 10
        };

        m_displayStyle.ColorH = "#6396C2";
        m_displayStyle.ColorE = "#8e870e";
        m_displayStyle.ColorP = "#e20df2";
        m_displayStyle.ColorNPSH = "#a90d41";
        m_displayStyle.ColorEquipment = "#013317";
        m_displayStyle.ColorEqualParaCurvesE = "#402db7";
        m_displayStyle.ColorCurveLabel = "#28004D";
        m_displayStyle.ColorCurveSize = 10;

        //初始化面板
        initialMainPanel(m_divChartName);

        //绘制网格线
        createGridLineX();
        createGridLineY();


        //绘制坐标
        createXAxis();
        createYAxis();


        //
        var maxCurveWidth = 2;
        if (m_chartObject.SimWaterCurveQH != null) {
            maxCurveWidth = 1;
        }
        var simuWaterCurveWidth = 2;
        if (m_chartObject.SimJieZhiCurveQH != null) {
            simuWaterCurveWidth = 1;
        }

        var curveMaxPathQH = createCurveQH("MaxWaterCurveQH", m_chartObject.MaxWaterCurveQH, maxCurveWidth);
        if (m_chartType == 1 && m_pumpInfo.MaxD2 != null && m_pumpInfo.MaxD2 > 1) {//叶轮直径
            drawTextByQH("MaxD2Text", m_pumpInfo.MaxD2 + "mm", m_chartObject.MaxWaterCurveQH[0], 8, m_displayStyle.ColorCurveLabel, 7, 3);
        }

        if (m_chartObject.SimJieZhiCurveQH == null) {
            if(m_isDispCurveQE)
                createCurveQE("MaxWaterCurveQE", m_chartObject.MaxWaterCurveQE, maxCurveWidth);
            createCurveQP("MaxWaterCurveQP", m_chartObject.MaxWaterCurveQP, maxCurveWidth);
        }

        createCurveNPSH("MaxWaterCurveNPSH", m_chartObject.MaxWaterCurveNPSH, maxCurveWidth);

        //
        createCurveQH("MinWaterCurveQH", m_chartObject.MinWaterCurveQH, 1);
        if (ChartFullInfo.ChartType == 1 && m_chartObject.MinWaterCurveQH != null) {//叶轮直径
            drawTextByQH("MinD2Text", m_pumpInfo.MinD2 + "mm", m_chartObject.MinWaterCurveQH[0], 8, m_displayStyle.ColorCurveLabel, 7, 3);
        }



        //暂时不显示
        //  if(m_isDispCurveQE)
        //createCurveQE("MinWaterCurveQE", m_chartObject.MinWaterCurveQE, 1);
        //createCurveQP("MinWaterCurveQP", m_chartObject.MinWaterCurveQP, 1);
        //createCurveNPSH("MinWaterCurveNPSH", m_chartObject.MinWaterCurveNPSH, 1);

        var curveMaxPathQH = createCurveQH("SimWaterCurveQH", m_chartObject.SimWaterCurveQH, simuWaterCurveWidth);
        if (ChartFullInfo.ChartType == 1 && m_chartObject.SimWaterCurveQH != null) {//叶轮直径
            drawTextByQH("WrkD2Text", m_pumpInfo.WrkD2 + "mm", m_chartObject.SimWaterCurveQH[0], 8, m_displayStyle.ColorCurveLabel, 7, 3);
        }


        if (m_isDispCurveQE)
            createCurveQE("SimWaterCurveQE", m_chartObject.SimWaterCurveQE, simuWaterCurveWidth);
        createCurveQP("SimWaterCurveQP", m_chartObject.SimWaterCurveQP, simuWaterCurveWidth);
        createCurveNPSH("SimWaterCurveNPSH", m_chartObject.SimWaterCurveNPSH);



        if (m_chartObject.SimJieZhiCurveQH != null) {
            //$("#SimJieZhiCurveQH").remove();
            //$("#SimJieZhiCurveQE").remove();
            //$("#SimJieZhiCurveQP").remove();

            createCurveQH("SimJieZhiCurveQH", m_chartObject.SimJieZhiCurveQH, 1, null, true, "10, 10");
            if (m_isDispCurveQE)
                createCurveQE("SimJieZhiCurveQE", m_chartObject.SimJieZhiCurveQE, 1, null, true, "10, 10");
            createCurveQP("SimJieZhiCurveQP", m_chartObject.SimJieZhiCurveQP, 1, null, true, "10, 10");
        }




        //初始化工作曲线
        intitalWrkCurveInfo();


        //
        if (m_chartObject.SpectrumList != null) {
            for (var i = 0 ; i < m_chartObject.SpectrumList.length; i++) {
                var subSpectrumCurve = m_chartObject.SpectrumList[i];
                createCurveQH("SpectrumList" + i, subSpectrumCurve.QH, 1);    
                if (subSpectrumCurve.CurveName == null || subSpectrumCurve.CurveName == "") {
                    drawTextByQH("SpectrumListText" + i, subSpectrumCurve.CurvePara + "mm", subSpectrumCurve.QH[0], 8, m_displayStyle.ColorCurveLabel, 7, 3);
                }
                else {
                    drawTextByQH("SpectrumListText" + i, subSpectrumCurve.CurveName, subSpectrumCurve.QH[0], 8, m_displayStyle.ColorCurveLabel, 7, 3);
                }
            }
        }


        //等效线
        if (m_chartObject.EqualParaCurvesE != null) {
            for (var i = 0 ; i < m_chartObject.EqualParaCurvesE.length; i++) {
                var points = m_chartObject.EqualParaCurvesE[i].PointInfo;
                if (points.length >= 4) {  //曲线
                    createCurveQH("EqualParaCurvesE" + i, points, 1, m_displayStyle.ColorEqualParaCurvesE);
                    drawTextByQH("EqualParaCurvesEText" + i, m_chartObject.EqualParaCurvesE[i].CurvePara + "%", points[0], 8, m_displayStyle.ColorEqualParaCurvesE, -1, 3, "middle");
                } else if (points.length == 2 || points.length == 3) { //直线
                    createLineQH("EqualParaCurvesE" + i, points[0], points[1], 1, m_displayStyle.ColorEqualParaCurvesE);
                    drawTextByQH("EqualParaCurvesEText" + i, m_chartObject.EqualParaCurvesE[i].CurvePara + "%", points[0], 8, m_displayStyle.ColorEqualParaCurvesE, -1, 3, "middle");
                }
                else if (points.length == 1) {
                    createPointQH("EqualParaCurvesE" + i, points[0], 3, m_displayStyle.ColorEqualParaCurvesE);
                    drawTextByQH("EqualParaCurvesEText" + i, m_chartObject.EqualParaCurvesE[i].CurvePara + "%", points[0], 8, m_displayStyle.ColorEqualParaCurvesE, -1, 3, "middle");
                }
            }
        }


        //绘制型谱
        craeteSpectrumShape(m_chartObject.SpectrumShape);

        //装置曲线
        //CreateEquipmentCurve();

        //设置设计点
        drawDesignPoint(m_displayStyle.DesignPointDispType);

        //
        if (ChartFullInfo.LogoText != null && ChartFullInfo.LogoText != "")
            setTextLogo(ChartFullInfo.LogoText);

        createVerticalLine();

        return this;
    };

    this.setToolTipName = function (toolTipName) {
        m_toolTipContent = $("#" + toolTipName);
    };

    this.removeByName = function (name) {
        m_svg.removeByName(name);
    };

    //设置物体显示
    this.setObjectVisibleByID = function (objName, isDisp) {
        var obj = m_svg.getPathByName(name);
        if (obj == null)
            return;
        if (isDisp) {
            series.style.display = "";
        } else {
            series.style.display = "none";
        }
    };

    this.setObjectVisibleByTag = function (objTag, isDisp) {
        var list = $("path[tag='" + objTag + "']");
        if (list.length == 0)
            return;

        if (isDisp) {
            list.show();
        } else {
            list.hide();
        }
    };

    this.intersection = function (isShow) {
        intersection(isShow);
    };

    this.getHbyQ4WrkWaterCurve = function (q) {
        return getHbyQ4WrkWaterCurve(q);
    };

    this.getEbyQ4WrkWaterCurve = function (q) {
        return getEbyQ4WrkWaterCurve(q);
    };

    this.getPbyQ4WrkWaterCurve = function (q) {
        return getPbyQ4WrkWaterCurve(q);
    };
    //设计点显示方式(eDesignPointDispType) Cross 0  LeftDownTriangle 2
    this.SetDesignPointStyle = function (type) {
        var list = $("path[tag='DesignPoint1']");
        list.remove();

        drawDesignPoint(type);
    };
    //用出口压力MPa代替扬程H
    this.IsOutletPressReplaceH = function (isReplace) {
        m_isOutletPressReplaceH = isReplace;
    };
    //流量单位
    this.UnitQ = function (unit) {
        m_unitQ = unit;
    };
    this.dispVerticalLine = function (disp) {
        dispVerticalLine(disp);
    };
    //重新刷新装置曲线
    this.RefreshEquipmentCurve = function (equipZeroH) {
        m_equipZeroH = equipZeroH;
        CreateEquipmentCurve();
    };
    //设置装置曲线静扬程
    this.SetEquipZeroH = function (equipZeroH) {
        m_equipZeroH = equipZeroH;
    };
    //设置设计点公差
    this.SetDesignPointTolerance = function () {
    	var selectModelString = localStorage.getItem("SelectParas");
        if (selectModelString == null || selectModelString == "") {
           m_designPointTolerance = TxPointTolerance.GetDefaultGradeParas(); 
           return;
        } 
        var selectParas = JSON.parse(selectModelString);  
       
        m_designPointTolerance = [selectParas.MinRatioQ/100, selectParas.MaxRatioQ/100, selectParas.MinRatioH/100, selectParas.MaxRatioH/100];
    };
   
    //显示装置曲线
    this.DispEquipmentCurve = function (isDisp) {
        m_dispEquipmentCurve = isDisp;
        if (isDisp) {
            $("#EquipmentCurve").show();

            //var char = 'http://www.w3.org/2000/svg',
            //path = document.getElementsByTagNameNS(char, 'path')[0],
            //var path = document.getElementById("EquipmentCurve");
            var pathEquipmentCurve = document.getElementById("EquipmentCurve");//.getElementsByTagNameNS(char, 'path')[0],
            var len = pathEquipmentCurve.getTotalLength();

            pathEquipmentCurve.style.strokeDasharray = len;
            pathEquipmentCurve.style.strokeDashoffset = len;
            pathEquipmentCurve.style.animation = 'act 1s linear forwards';

        }
        else {
            $("#EquipmentCurve").hide();
        }
    }

    this.toggleVerticalLine = function () {
        if (m_infoDv4VerticalLine.is(":hidden")) {
            dispVerticalLine(true);
        }
        else {
            dispVerticalLine(false);
        }
    };
    this.GetTotalHeigth = function () {
        return m_chartSize.TotalHeight;
    };
    this.GetTotalWidth = function () {
        return m_chartSize.TotalWidth;
    };
    this.GetCoordinatePara = function () {
        return m_coordinatePara;
    };
    
    this.drawDesignPoint = function (dpQ, dpH) {
        if (m_chartObject == null)
            m_chartObject = {};
        m_chartObject.DesignPoint1 = {};
        m_chartObject.DesignPoint1.X = dpQ;
        m_chartObject.DesignPoint1.Y = dpQ;
        drawDesignPoint(m_displayStyle.DesignPointDispType);
    };
};


