﻿

var extend = function (c, o) {
    if (o == null) {
        return c;
    }
    ;
    if (c == null) {
        c = {};
    }
    ;
    for (var key in o) {
        c[key] = o[key];
    }
    ;
    return c;
};

var svgObject = function () {
    var elementType = {
        "svg": "svg",
        "path": 'path',
        "rect": "rect",
        "g": "g",
        "circle": "circle",
        "text": "text"
    },
            area = null,
            node = null,
            paths = null,
            importAddress = "http://www.w3.org/2000/svg";

    this.createArea = function (attr, style) {

        var areaAttr = extend({}, attr);

        var areaStyle = extend({}, style);

        node.appendChild(area = document.createElementNS(importAddress,
            elementType.rect).setAttr(areaAttr).setStyle(areaStyle));

        return area;
    };

    this.createRect = function (attr, style, name) {
        var
               areaAttr = extend({}, attr),

               areaStyle = extend({}, style),

               rect = document.createElementNS(importAddress, elementType.rect).setAttr(areaAttr).setStyle(areaStyle);
        rect.createKey(name);
        //paths[name] = rect.setAttr();
        node.appendChild(rect);
    }

    this.createText = function (attr, style, txt, zIndex, name, transform) {
        var g = document.createElementNS(importAddress, elementType.g);
        var textNode = document.createTextNode(txt);
        text = document.createElementNS(importAddress, elementType.text);
        text.createKey(name); //就是ID
        if (transform != null)
            text.setAttr("transform", transform);
        text.setAttr(attr).setAttr("style", style || "").appendChild(textNode);
        g.setAttr("zIndex", (zIndex || 7)).appendChild(text);
        node.appendChild(g);

    };

    this.removeByName = function (name) {
        var elm = this.getPathByName(name);
        if (typeof elm === "Element") {
            node.remove(this.getPathByName(name));
        }
        //if (paths[name] != null)
        //    node.removeChild(paths[name])
    };

    this.createCircle = function (name, attr, style) {
        var
                circle = document.createElementNS(importAddress, elementType.circle);
        circle.createKey(name);
        // paths[name] = circle;
        if (style != null) {
            circle.setAttr(attr);
        }
        else {
            circle.setAttr(attr).setAttr("style", style);
        }
        // circle.setAttr("id", name);
        node.appendChild(circle);
        return circle;
    };

    this.createPath = function (name, value, attr, style) {
        var path = document.createElementNS(importAddress, elementType.path);
        //paths[name] = path;
        path.createKey(name);
        node.appendChild(path);
        this.setPathValue(path, value, attr, style)
        return path;
    };

    this.getPathByName = function (name) {
        return document.getElementById(name);
    };

    this.setPathValue = function (path, value, attr, style) {
        if (value == null) {
            return;
        }
        path = typeof path === "string" ? this.getPathByName(path) : path;
        path.setAttr("d", value).setAttr(attr || {}).setStyle(style || {});
    };

    this.getNode = function () {
        return node;
    };

    this.init = function (divName, divWidth, divHeight, svgClick, svgMove, svgID) {

        var container = document.getElementById(divName);

        paths = new Object();

        var size = {
            "width": divWidth,
            "height": divHeight
        };
        if (node == null) {
            node = document.createElementNS(importAddress, elementType.svg);
            node.setAttribute("xmlns", "http://www.w3.org/2000/svg")
            node.setAttribute("shape-rendering", "crispEdges");
            node.setAttribute("version", "1.1");
            if (svgID != null)
                node.setAttribute("id", svgID);
            node.on("mousemove", function (e) {
                if (typeof svgMove == "function") {
                    var e = e || window.event;
                    svgMove(e, node);
                }
            });
            node.on("click", function (e) {
                if (typeof svgClick == "function") {
                    var e = e || window.event;
                    svgClick(e, node);
                }
            });
        }
        container.appendChild(node.setAttr(size));
        return this;
    };
};
