function setSeiresImg(imgId, seriesID, imgFileName) {
	if (imgId == null) return;
	if (imgFileName == null || imgFileName == '') return;
	//图片下载成功 默认保存在本地相对路径的"_downloads"文件夹里面, 如"_downloads/logo.jpg"
	//var filename = loadUrl.substring(loadUrl.lastIndexOf("/") + 1, loadUrl.length);
	var relativePath = "_downloads/Series" + seriesID + "/" + imgFileName;
	//检查图片是否已存在
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
		console.log("图片存在,直接设置=" + relativePath);
		//如果文件存在,则直接设置本地图片
		setSeiresImgFromLocal(imgId, seriesID, imgFileName);
	}, function(e) {
		console.log("图片不存在,联网下载=" + relativePath);
		//如果文件不存在,联网下载图片
		setSeiresImgFromNet(imgId, seriesID, imgFileName);
	});
}

/*给图片标签<img>设置本地图片
 * imgId 图片标签<img>的id
 * relativePath 本地相对路径 例如:"_downloads/logo.jpg"
 */
function setSeiresImgFromLocal(imgId, seriesID, imgFileName) {
	var relativePath = "_downloads/Series" + seriesID + "/" + imgFileName;
	//本地相对路径("_downloads/logo.jpg")转成SD卡绝对路径("/storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/downloads/logo.jpg");
	var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
	//给<img>设置图片
	$id(imgId).setAttribute("src", sd_path);
}

/*联网下载图片,并设置给<img>*/
function setSeiresImgFromNet(imgId, seriesID, imgFileName) {
	return;
	//先设置下载中的默认图片
	$id(imgId).setAttribute("src", "../images/loading.gif");
	//设置下载WEB地址
	var loadUrl = GlobalParas.ServiceUrlXPump + "/Data/Series" + seriesID + "/" + imgFileName;
	//设置下载后保存的本地路径
	var relativePath = "_downloads/Series" + seriesID + "/" + imgFileName;
	//创建下载任务
	var loadOptions={
            filename: relativePath
    };
    //创建下载任务
	var dtask = plus.downloader.createDownload(loadUrl, loadOptions, function(d, status) {
		if (status == 200) {
			//下载成功
			console.log("下载成功:" + loadUrl);
			//设置到本地图片显示
			setSeiresImgFromLocal(imgId, seriesID, imgFileName);
		} else {
			//下载失败,需删除本地临时文件,否则下次进来时会检查到图片已存在
			console.log("下载失败:" + status + "==" + imgFileName);
			//dtask.abort();//文档描述:取消下载,删除临时文件;(但经测试临时文件没有删除,故使用delFile()方法删除);	
			delFile(relativePath);
		}
	});
	//启动下载任务
	dtask.start();
}

/*删除指定文件*/
function delSeiresFile(relativePath) {
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
		entry.remove(function(entry) {
			console.log("文件删除成功==" + relativePath);
		}, function(e) {
			console.log("文件删除失败=" + relativePath);
		});
	});
}

/*根据id查找元素*/
function $id(id) {
	return document.getElementById(id);
}