var TxLocalSeriesStorage = window.TxLocalSeriesStorage = TxLocalSeriesStorage || {};
(function () {
    var expTime = 1000 * 60 * 60 * 24 * 3;//本地存储过期时间
    var curVersion = 20180207;

    //
    TxLocalSeriesStorage.GetAllSeries = function () {
        var storeStr = window.localStorage.getItem("AllSeriesEntitys");
        if (storeStr == null)
            return null;

        var dataObj = JSON.parse(storeStr);
        var expSpan = new Date().getTime() - dataObj.time;
        if (expSpan > expTime) {
            console.log('信息已过期,Info42');
            return null;
        }
        if (dataObj.version != curVersion) {
            console.log('信息已过期,Info46');
            return null;
        }

        return dataObj.entity;
    };

    //
    TxLocalSeriesStorage.GetSeriesNameByID = function (ID) {
        var dataObj = TxLocalSeriesStorage.GetAllSeries();
        if (dataObj == null) {
            return '';
        }
        for (var i = 0; i < dataObj.length; i++) {
            if (dataObj[i].ID == ID) {
                return dataObj[i].Name;
            }
        }

        return "";
    };
    //
    TxLocalSeriesStorage.GetSeriesBySeriesID = function (SeriesID) {
        var all = TxLocalSeriesStorage.GetAllSeries();
        if (all == null) {
            return null;
        }
        for (var i = 0; i < all.length; i++) {
            if (all[i].ID == SeriesID)
                return all[i];
        }
        return null;
    };
    //
    TxLocalSeriesStorage.SaveAllSeries = function (entitys) {
        if (entitys == null || entitys == undefined)
            return;
        if (entitys.Status == "exception" || entitys.Status == "error")
            return;

        var curTime = new Date().getTime();
        window.localStorage.setItem("AllSeriesEntitys", JSON.stringify({ entity: entitys, time: curTime, version: curVersion }));//plus.storage.setItem
    };

    //
    TxLocalSeriesStorage.RemoveAllSeries = function () {
        window.localStorage.removeItem("AllSeriesEntitys");
    };



    TxLocalSeriesStorage.GetPumpInfoBySeriesID = function (CorpID, SeriesID) {
        var key = "PumpFullBySeriesID" + SeriesID + "CorpID" + CorpID;
        var storeStr = window.localStorage.getItem(key);
        if (storeStr == null)
            return null;
        var dataObj = JSON.parse(storeStr);
        var expSpan = new Date().getTime() - dataObj.time;
        if (expSpan > expTime) {
            //console.log('信息已过期,Info126');
            return null;
        }
        if (dataObj.version != curVersion) {
            //console.log('信息已过期,Info130');
            return null;
        }

        return dataObj.entity;
    };

    TxLocalSeriesStorage.RemovePumpInfoBySeriesID = function (CorpID, SeriesID) {
        var key = "PumpFullBySeriesID" + SeriesID + "CorpID" + CorpID;
        window.localStorage.removeItem(key);
    };


    //
    TxLocalSeriesStorage.SavePumpInfoBySeriesID = function (CorpID, SeriesID, entitys) {
        if (entitys == null || entitys == undefined)
            return;
        if (entitys.Status == "exception" || entitys.Status == "error")
            return;
        var key = "PumpFullBySeriesID" + SeriesID + "CorpID" + CorpID;
        var curTime = new Date().getTime();
        window.localStorage.setItem(key, JSON.stringify({ entity: entitys, time: curTime, version: curVersion })); 

        //var storeStr = JSON.stringify(entitys); //JSON.parse
        //window.localStorage.setItem("AllPumpsBySeriesID" + SeriesID, storeStr);
    };



})(); //闭包结束