﻿// 对Date的扩展，将 Date 转化为指定格式的String   
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，   
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)   
// 例子：   
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423   
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18  
Date.prototype.Format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份 
        "d+": this.getDate(), //日 
        "H+": this.getHours(), //小时 
        "m+": this.getMinutes(), //分 
        "s+": this.getSeconds(), //秒 
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
        "S": this.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};

//输入 new Date() , 输出 yyyy-MM-dd HH:mm:ss
function timeFormatToYMDHMS(da) {

    //var da = value;//new Date(parseInt(value.replace("/Date(", "").replace(")/", "").split("+")[0]));

    return da.getFullYear() + "-" + (da.getMonth() + 1) + "-" + da.getDate() + " " + da.getHours() + ":" + da.getMinutes() + ":" + da.getSeconds();

}
//输入 new Date() , 输出 yyyy-MM-dd
function timeFormatToYMD(da) {

    //var da = value;//new Date(parseInt(value.replace("/Date(", "").replace(")/", "").split("+")[0]));

    return da.getFullYear() + "-" + (da.getMonth() + 1) + "-" + da.getDate();

}

//输入 new Date() , 输出 yyyy年 MM月 dd日
function timeFormatToYMDCH(da) {

    //var da = value;//new Date(parseInt(value.replace("/Date(", "").replace(")/", "").split("+")[0]));

    return da.getFullYear() + "年" + (da.getMonth() + 1) + "月" + da.getDate()+"日";

}
//输入 new Date() , 输出 yyyy-MM
function timeFormatToYM(da) {

    //var da = value;//new Date(parseInt(value.replace("/Date(", "").replace(")/", "").split("+")[0]));

    return da.getFullYear() + "-" + (da.getMonth() + 1);

}
//输入 new Date() , 输出 yyyy
function timeFormatToY(da) {

    //var da = value;//new Date(parseInt(value.replace("/Date(", "").replace(")/", "").split("+")[0]));

    return da.getFullYear();

}

function GetDateStr(AddDayCount) {//获取日期函数 今天就是0 昨天就是-1 前天就是-2
    var dd = new Date();
    dd.setDate(dd.getDate() + AddDayCount);//获取AddDayCount天后的日期
    var y = dd.getFullYear();
    var m = dd.getMonth() + 1;//获取当前月份的日期
    var d = dd.getDate();
    return y + "-" + m + "-" + d;
}
function GetDateStr2(AddDayCount) {//获取日期函数 今天就是0 昨天就是-1 前天就是-2
    var dd = new Date();
    dd.setDate(dd.getDate() + AddDayCount);//获取AddDayCount天后的日期
    var y = dd.getFullYear();
    var m = dd.getMonth() + 1;//获取当前月份的日期
    var d = dd.getDate();
    return y + "/" + m + "/" + d;
}
function NowDate() {
    var mydate = new Date();
    var str = "" + mydate.getFullYear() + "/";
    str += (mydate.getMonth() + 1) + "/";
    str += mydate.getDate() + " ";
    return str;
}
//计算时间差
function GetDateDiff(startTime, endTime, diffType) {
    //将xxxx-xx-xx的时间格式，转换为 xxxx/xx/xx的格式 
    startTime = startTime.replace(/\-/g, "/");
    endTime = endTime.replace(/\-/g, "/");

    //将计算间隔类性字符转换为小写
    diffType = diffType.toLowerCase();
    var sTime = new Date(startTime);      //开始时间
    var eTime = new Date(endTime);  //结束时间
    //作为除数的数字
    var divNum = 1;
    switch (diffType) {
        case "second":
            divNum = 1000;
            break;
        case "minute":
            divNum = 1000 * 60;
            break;
        case "hour":
            divNum = 1000 * 3600;
            break;
        case "day":
            divNum = 1000 * 3600 * 24;
            break;
        default:
            break;
    }
    return parseInt((eTime.getTime() - sTime.getTime()) / parseInt(divNum));
}
//判断时间是否在当前时间之前
function diffDate(time) {

    var d = new Date(Date.parse(time.replace(/\-/g, "\/")));

    var dB = new Date(Date.parse(GetDateStr(0).replace(/\-/g, "\/")));


    if (dB > d && !PanDuanRiQi(d)) {
        return true;
    }
    return false;
}

//判断开始时间是否在结束时间之前
function diffDate(startTime, endTime) {

    var d = new Date(Date.parse(startTime.replace(/\-/g, "\/")));

    var dB = new Date(Date.parse(endTime.replace(/\-/g, "\/")));


    if (dB > d && !PanDuanRiQi(d)) {
        return false ;
    }
    return true;
}

function PanDuanRiQi(time) {//判断日期是否等于当前日期
    var dd = new Date();
    dd.setDate(dd.getDate());

    var y = dd.getFullYear();
    var m = dd.getMonth() + 1;//获取当前月份的日期
    var d = dd.getDate();

    var dd1 = time;
    var y1 = dd1.getFullYear();
    var m1 = dd1.getMonth() + 1;//获取当前月份的日期
    var d1 = dd1.getDate();
    if (y == y1 && m == m1 && d == d1) {
        return true;
    } else {
        return false;
    }

}

//获得上个月在昨天这一天的日期  
function getLastMonthYestdy(date) {

    var daysInMonth = new Array([0], [31], [28], [31], [30], [31], [30], [31], [31], [30], [31], [30], [31]);
    var strYear = date.getFullYear();
    var strDay = date.getDate();
    var strMonth = date.getMonth() + 1;
    if (strYear % 4 == 0 && strYear % 100 != 0) {
        daysInMonth[2] = 29;
    }
    if (strMonth - 1 == 0) {
        strYear -= 1;
        strMonth = 12;
    }
    else {
        strMonth -= 1;
    }
    strDay = daysInMonth[strMonth] >= strDay ? strDay : daysInMonth[strMonth];
    if (strMonth < 10) {
        strMonth = "0" + strMonth;
    }
    if (strDay < 10) {
        strDay = "0" + strDay;
    }
    datastr = strYear + "-" + strMonth + "-" + strDay;
    return datastr;
}



//获得上一年在昨天这一天的日期  
function getLastYearYestdy(date) {
    var strYear = date.getFullYear() - 1;
    var strDay = date.getDate();
    var strMonth = date.getMonth() + 1;
    if (strMonth < 10) {
        strMonth = "0" + strMonth;
    }
    if (strDay < 10) {
        strDay = "0" + strDay;
    }
    datastr = strYear + "-" + strMonth + "-" + strDay;
    return datastr;
}
//月份格式 : 如2018-01
function getMonthString(strDate) {
	if(strDate == null) {
		return null;
	}
	 console.log(strDate);
	var st = strDate;
	var a = st.split(" ");
	var b = a[0].split("-");

	var date = b[0]+"年"+ (b[1])+"月";
	return date;
}
//日期格式 : 如2018-01-01
function getDateFromString(strDate) {
	if(strDate == null) {
		return null;
	}
	//console.log(strDate);
	var st = strDate;
	var a = st.split(" ");
	var b = a[0].split("-");
	if(b[1]<10){
		b[1] = b[1].replace("0","");
	}
	if(b[2]<10){
		b[2] = b[2].replace("0","");
	}
	
	var date =b[1]+"月"+ b[2]+"日";

	
	return date;
}